C-----------------------------------------------------------------------
      SUBROUTINE SFPLOT(SFCH_FNAME,SFCH_FSCR,FILE_DST,DCORR)

      INCLUDE 'sfch_graph.inc'
c      INCLUDE 'sfch_graph_ini.inc'

      INTEGER   MDOC,IN,IERR
      INTEGER   NB_OF_PS_PAGES
      CHARACTER SFCH_FNAME*(*),SFCH_FSCR*(*),FILE_DST*(*)
      REAL      DCORR

      REAL*4 RCH4
      CHARACTER CH4*4
      EQUIVALENCE (RCH4,CH4)
c ----------------------------------------------------------------------
      RGB(1,1) = 0.0000
      RGB(2,1) = 0.0000
      RGB(3,1) = 0.0000
      COLNAM(1) = 'BLACK'
      RGB(1,2) = 1.0000
      RGB(2,2) = 1.0000
      RGB(3,2) = 1.0000
      COLNAM(2) = 'WHITE'
      RGB(1,3) = 1.0000
      RGB(2,3) = 0.0000
      RGB(3,3) = 0.0000
      COLNAM(3) = 'RED'
      RGB(1,4) = 0.0000
      RGB(2,4) = 1.0000
      RGB(3,4) = 0.0000
      COLNAM(4) = 'GREEN'
      RGB(1,5) = 0.0000
      RGB(2,5) = 0.0000
      RGB(3,5) = 1.0000
      COLNAM(5) = 'BLUE'
      RGB(1,6) = 1.0000
      RGB(2,6) = 1.0000
      RGB(3,6) = 0.0000
      COLNAM(6) = 'YELLOW'
      RGB(1,7) = 0.8000
      RGB(2,7) = 0.5000
      RGB(3,7) = 0.0000
      COLNAM(7) = 'ORANGE'
      RGB(1,8) = 0.5000
      RGB(2,8) = 1.0000
      RGB(3,8) = 0.0000
      COLNAM(8) = 'LIME GREEN'
      RGB(1,9) = 0.5000
      RGB(2,9) = 0.0000
      RGB(3,9) = 1.0000
      COLNAM(9) = 'PURPLE'
      RGB(1,10) = 0.5000
      RGB(2,10) = 1.0000
      RGB(3,10) = 1.0000
      COLNAM(10) = 'CYAN'
      RGB(1,11) = 1.0000
      RGB(2,11) = 0.5000
      RGB(3,11) = 1.0000
      COLNAM(11) = 'PINK'
      RGB(1,12) = 0.3000
      RGB(2,12) = 0.8000
      RGB(3,12) = 1.0000
      COLNAM(12) = 'SKY BLUE'
      RGB(1,13) = 1.0000
      RGB(2,13) = 1.0000
      RGB(3,13) = 0.7000
      COLNAM(13) = 'CREAM'
      RGB(1,14) = 0.0000
      RGB(2,14) = 1.0000
      RGB(3,14) = 1.0000
      COLNAM(14) = 'TURQUOISE'
      RGB(1,15) = 1.0000
      RGB(2,15) = 0.0000
      RGB(3,15) = 1.0000
      COLNAM(15) = 'LILAC'
      RGB(1,16) = 0.8000
      RGB(2,16) = 0.0000
      RGB(3,16) = 0.0000
      COLNAM(16) = 'BRICK RED'
      RGB(1,17) = 0.5000
      RGB(2,17) = 0.0000
      RGB(3,17) = 0.0000
      COLNAM(17) = 'BROWN'
      RGB(1,18) = 0.9700
      RGB(2,18) = 0.9700
      RGB(3,18) = 0.9700
      COLNAM(18) = 'LIGHT GREY'
      RGB(1,19) = 1.0000
      RGB(2,19) = 1.0000
      RGB(3,19) = 1.0000
      COLNAM(19) = 'WHITE'
c ----------------------------------------------------------------------

      IERR=0
      MDOC=0
      IN  =8

      CALL READDATA(MDOC,SFCH_FSCR,DCORR,IERR)
      IF(IERR.NE.0) GO TO 100

      IF (L_NA .AND. L_NRFLS) THEN
         CALL FIRSTSTEP(MDOC,IN,TOTNBRES,NBOFCHAIN,DISPSIG,AVERDENS
     +        ,SIGMADENS,IERR,CODE_NDB,FILE_DST)
C     +        ,SIGMADENS,IERR,CODE_NDB,SFCH_FSCR)
         IF(IERR.NE.0) GO TO 100

c      write(*,*) MDOC,IN,TOTNBRES,NBOFCHAIN,DISPSIG,AVERDENS
c     +              ,SIGMADENS,IERR

C         NB_OF_PS_PAGES = INT(REAL(TOTNBRES-1+(NBOFCHAIN-1)*2)/150.)+4
C        The last page with Comments and Remarks is no more printed
         NB_OF_PS_PAGES = INT(REAL(TOTNBRES-1+(NBOFCHAIN-1)*2)/150.)+3
      ELSE IF (L_NRFLS) THEN
C         NB_OF_PS_PAGES = 3
C        The last page with Comments and Remarks is no more printed
         NB_OF_PS_PAGES = 2
      ELSE
         NB_OF_PS_PAGES = 1
      ENDIF

      CALL PSSETPG( NB_OF_PS_PAGES )

      CALL CUSTOM(MDOC,SFCH_FNAME)

      CALL INITPS(IERR)
      IF(IERR.NE.0) GO TO 100
c      CALL INITHTML(IERR)
c      IF(IERR.NE.0) GO TO 100

      CALL TEXTPS(DCORR)

      IF (L_NRFLS) THEN
         CALL NEWPAGEPS

         YLOWBOX = 560.0
         YSIZREG = 220.0
         XSIZREG = 230.0

         CALL PSTRANSLATE (XORIGN, YLOWBOX)
         CALL WILSONPS

         CALL PSTRANSLATE (XSIZREG, 0.0)
         CALL EFFECTIVPS

         CALL PSTRANSLATE (-XSIZREG, -YSIZREG)
         CALL COMPLETEPS

         IF(NHTEST.LE.0) THEN
           CALL PSTRANSLATE (XSIZREG, 0.0)
           CALL ERRORPLOTPS
         ELSE
           CALL PSTRANSLATE (XSIZREG, 0.0)
           CALL PTWINPLOTPS
         ENDIF

         CALL PSTRANSLATE (-XSIZREG, -YSIZREG)
         CALL STEREOGRAM

         IF (L_NA) THEN
            CALL PSTRANSLATE (XSIZREG, 0.0)
            CALL LUZZATIPS
         ELSE
           CALL PSTRANSLATE (XSIZREG, 0.0)
           CALL TWINPLOTPS
         ENDIF

         CALL SEPARATE_PLOTS(IERR)
         IF(IERR.NE.0) GO TO 100

      ENDIF

      IF (L_NA .AND. L_NRFLS) THEN
         CALL BYRESPLOT(MDOC,IN,IERR)
         IF(IERR.NE.0) GO TO 100
      ENDIF

      IF (L_NA .AND. L_NRFLS) THEN
         CALL LASTSTEP(IN,IERR)
         IF(IERR.NE.0) GO TO 100
      ENDIF

 100  CONTINUE

      CALL FINALPS

      RETURN

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE READDATA  -  Read in all the data generated by the SF suite
C
C-----------------------------------------------------------------------
      SUBROUTINE READDATA (MDOC,SFCH_FNAME,DCORR,IERR)

      INCLUDE 'sfch_graph.inc'

      INTEGER*4 MT, M, MDOC, IERR ,I4
      REAL      DCORR
      CHARACTER PATH*1, EXT*3
      CHARACTER FILE_RES*256,SFCH_FNAME*(*)

      INTEGER*4 I ,ILN ,I0 , J , IJ ,ISM_TWIN(3,3)

      LOGICAL NULL_STRING

      LOGICAL L_DEBUG_PRINT

      REAL*4 RCH4
      CHARACTER CH4*4
      EQUIVALENCE (RCH4,CH4)
C ----------------------------


c      L_DEBUG_PRINT = .TRUE.
      L_DEBUG_PRINT = .FALSE.

      MT   = 10
      M    = 99
      PATH = ' '
      EXT  = '   '
      IERR = 0

      CALL LENSTR_BL(SFCH_FNAME,ILN)

C      FILE_RES = 'sfcheck.res'

      FILE_RES = SFCH_FNAME(1:ILN)//'.res'

      CALL OPENUR (MT,M,PATH,FILE_RES,EXT,IERR)
      IF(IERR.NE.0) GO TO 9000

C      OPEN(MT,FILE='sfcheck.res',FORM='UNFORMATTED',
C     +     ACCESS='SEQUENTIAL',STATUS='OLD',ERR=9000)

      GOTO 1000

 9000 CONTINUE
      CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE_RESULT')
      IERR=1
      RETURN

 1000 READ(MT,ERR=900) RESULT

      DCORR_TOT = DCORR

      RCODE = RESULT(1,14)
      RCH4 = RCODE
      CODE = CH4
      RCODE_NDB(1) = RESULT(1,22)
      RCODE_NDB(2) = RESULT(2,22)
      RCH4 = RCODE_NDB(1)
      CODE_NDB(1:4) = CH4
      RCH4 = RCODE_NDB(2)
      CODE_NDB(5:8) = CH4
C     Use PDB code if NDB code not assigned
      L_CODE_NDB = .NOT.NULL_STRING(CODE_NDB)
      IF (.NOT.L_CODE_NDB) THEN
          CODE_NDB = CODE
          CODE_NDB(5:8) = '    '
      ENDIF

      CALL MSGDOC(MDOC,CODE_NDB)

      DO I=1,6
         CELL(I) = RESULT(5+I,14)
      ENDDO

      RSPGR(1) = RESULT(12,14)
      RSPGR(2) = RESULT(13,14)
      RSPGR(3) = RESULT(14,14)

      RCH4 =  RSPGR(1)
      SPGR(1:4) = CH4
      RCH4 =  RSPGR(2)
      SPGR(5:8) = CH4
      RCH4 =  RSPGR(3)
      SPGR(9:12) = CH4

      I0 = 0   
      DO I=1,10
         RNAME(I) = RESULT(I,21)
         IF(RNAME(I).NE.0.0) I0 = 1
         RCH4 = RNAME(I)
         I4 = I*4
         SNAME(I4-3:I4) = CH4
      ENDDO
      IF(I0.EQ.0) SNAME = ' '
      I0 = 0   
      DO I=1,3
         RDATE(I) = RESULT(10+I,21)
         IF(RDATE(I).NE.0.0) I0 = 1
         RCH4 = RDATE(I)
         I4 = I*4
         SDATE(I4-3:I4) = CH4
      ENDDO
      IF(I0.EQ.0) SDATE = ' '

      I0 = 0   
      DO I=1,19
         RNDB_TITLE(I) = RESULT(I,24)
         IF(RNDB_TITLE(I).NE.0.0) I0 = 1
         RCH4 = RNDB_TITLE(I)
         I4 = I*4
         NDB_TITLE(I4-3:I4) = CH4
      ENDDO
      IF(I0.EQ.0) NDB_TITLE = ' '
      I0 = 0   
      DO I=1,3
         RNDB_DATE(I) = RESULT(2+I,22)
         IF(RNDB_DATE(I).NE.0.0) I0 = 1
         RCH4 = RNDB_DATE(I)
         I4 = I*4
         NDB_DATE(I4-3:I4) = CH4
      ENDDO
      IF(I0.EQ.0) NDB_DATE = ' '
      NDB_DATE(11:12) = '  '

C     Use title from PDB if title from NDB absent

      IF (NULL_STRING(NDB_TITLE)) THEN
          NDB_TITLE = SNAME
      ENDIF
C     Use date from PDB if date from NDB absent
      IF (NULL_STRING(NDB_DATE)) THEN
          NDB_DATE = SDATE
      ENDIF
       
      NA = RESULT(2,14)
      L_NA = NA .NE. 0
      IF (L_DEBUG_PRINT) L_NA = .TRUE.
      NAHOH = RESULT(3,14)
      NHATOM = RESULT(15,14)

      RMS_L = RESULT(21,5)

      DO I=1,21
         RESVEC(I) = RESULT(I,1)
         LUZVEC(I) = RESULT(I,5)
         RFACVC(I) = RESULT(I,3)
         FMEVEC(I) = RESULT(I,7)
         BOVVEC(I) = RESULT(I,11)
         COMVEC(I) = RESULT(I,8)/100.0
         SIFVEC(I) = RESULT(I,9)
         FREVEC(I) = RESULT(I,31)
         EFFVEC(I) = RESULT(I,26)
         EFBVEC(I) = RESULT(I,27)
         ER1VEC(I) = RESULT(I,28)
         ER2VEC(I) = RESULT(I,30)

      ENDDO

      SOLV = RESULT(10,18)
      L_SOLV = SOLV .GE. 0

      NANISO    = RESULT(13,18)
      L_ANISO = NANISO .GT. 0
      CMATTHEWS = RESULT(14,18)
      L_CMATT = CMATTHEWS .GT. 0
      SOLVENT   = RESULT(15,18)
c      IF(NANISO.GT.0.0) THEN
c      WRITE(LINE,'('' Number of atoms with aniso_U :'',I6)') NANISO
c      CALL MSGDOC(MDC,LINE)
c      ENDIF
c      IF(CMATTHEWS.GT.0.0) THEN
c        WRITE(LINE,'('' Matthews coefficient     : '',F8.2)') CMATTHEWS 
c        CALL MSGDOC(MDC,LINE)
c        WRITE(LINE,'('' corresponding % solvent  : '',F8.2)') SOLVENT 
c        CALL MSGDOC(MDC,LINE)
c      ENDIF
      NC_ANISO = RESULT(1,32)
      L_NC_ANISO = NC_ANISO .GT. 0
      CKSOL    = RESULT(3,32)
      BSOL     = RESULT(4,32)
      B11      = RESULT(5,32)
      B22      = RESULT(6,32)
      B33      = RESULT(7,32)
      B12      = RESULT(8,32)
      B13      = RESULT(9,32)
      B23      = RESULT(10,32)
C         RFAC_ANISO=RESULT(14,32)
C         CC_ANISO  =RESULT(15,32)

c      IF(NC_ANISO.GT.0) THEN
c        CALL MSGDOC(MDC,' Anisothermal scaling:')
c        WRITE(LINE,'('' Beta:'',6F10.5)') B11,B22,B33,B12,B13,B23   
c        CALL MSGDOC(MDC,LINE)
c        WRITE(LINE,'('' Solvent correction: Ks,Bs:'',2F8.3)') 
c     *  CKSOL,BSOL   
c        CALL MSGDOC(MDC,LINE)

      NC_OVER   = RESULT(21,32)
      L_NC_OVER = NC_OVER .GT. 0
      EVAL1     = RESULT(11,32)
      EVAL2     = RESULT(12,32)
      EVAL3     = RESULT(13,32)

c      IF(NC_OVER.GT.0) THEN
c        CALL MSGDOC(MDC,
c     *  ' Anisotropic distribution of Structure Factors:')
c        WRITE(LINE,'('' Ratio of Eigen values :'',3F8.4)')
c     *  EVAL1,EVAL2,EVAL3    
c        CALL MSGDOC(MDC,LINE)
c      ENDIF

      IF (L_DEBUG_PRINT) L_SOLV = .TRUE.
      RES_REPORT  = RESULT(4,14)
      RFAC_REPORT = RESULT(5,14)
      RSMIN       = RESULT(2,15)
      RSMAX       = RESULT(3,15)
      RES_MIN     = RESULT(20,20)
      RES_MAX     = RESULT(21,20)
      RESEFF      = RESULT(19,15)
      NRFLS       = RESULT(1,15)
      L_NRFLS = NRFLS .NE. 0
      IF (L_DEBUG_PRINT) L_NRFLS = .TRUE.
      N_INPUT     = RESULT(16,15)
      COMPL       = RESULT(IPRROW,8)
      L_COMPL = COMPL .LT. 99.9
      IF (L_DEBUG_PRINT) L_COMPL = .TRUE.
      RSTAND      = RESULT(IPRROW,9)
      L_RSTAND = RSTAND .NE. 0
      IF (L_DEBUG_PRINT) L_RSTAND = .TRUE.
      BOVERALL    = RESULT(20,15)
      BOVER       = RESULT(10,10)
      RFAC        = RESULT(IPRROW,3)
      RCORR       = RESULT(IPRROW,4)
      RMSL        = RESULT(IPRROW,5)
      NCS         = RESULT(17,14)
      L_NCS = NCS .GT. 0
      IF (L_DEBUG_PRINT) L_NCS = .TRUE.
      BAVER       = RESULT(3,18)
      NCHAIN      = RESULT(16,14)
      RMRG        = RESULT(4,15)
      NMRG        = RESULT(5,15)
      NMRGT       = RESULT(6,15)
      L_RMRG = NMRGT .NE. 0
      IF (L_DEBUG_PRINT) L_RMRG = .TRUE.
      N_GT_SIG    = RESULT(15,15)
      N_GT_3SIG   = RESULT(7,15)
      NBAD_SD     = RESULT(17,15)
      NBAD_ABS    = RESULT(20,14)
      NBAD        = NBAD_SD + NBAD_ABS
      L_NBAD_ABS = NBAD_ABS .GT. 0
      IF (L_DEBUG_PRINT) L_NBAD_ABS = .TRUE.
      L_NBA = NBAD_SD .GT. 0
      IF (L_DEBUG_PRINT) L_NBA = .TRUE.
      NOUT        = RESULT(21,14)
      L_NOUT = NOUT .GT. 0
      IF (L_DEBUG_PRINT) L_NOUT = .TRUE.
      COMPL       = RESULT(21,8)
      RESEFF_COMP = RESULT(21,15)
      RFACS       = RESULT(19,10)
      SIGL        = RESULT(19,21)
      RESNL       = RESULT(20,21)
      RESXL       = RESULT(21,21)

      DO I=1,4
         RCR_PROGRAM(I) = RESULT(0+I,23)
         RCH4 = RCR_PROGRAM(I)
         I4 = I*4
         CR_PROGRAM(I4-3:I4) = CH4
      ENDDO

      CR_RES_MIN   = RESULT(6,22)
      CR_RES_MAX   = RESULT(7,22)
      CR_RES_RMIN  = RESULT(5,23)
      CR_RES_RMAX  = RESULT(6,23)
      L_RES = (CR_RES_RMAX.NE.0.0).AND.(RES_REPORT.NE.0.0).AND.
     +     (RES_REPORT.NE.CR_RES_RMAX)
      IF (L_DEBUG_PRINT) L_RES = .TRUE.
      CR_RFAC_CUT  = RESULT(7,23)
      CR_RFAC_ALL  = RESULT(12,22)
      CR_RFAC_OBS  = RESULT(13,22)
      CR_SIGMAR_I  = RESULT(11,23)
      CR_SIGMAR_F  = RESULT(12,23)
      CR_RFREE_ALL = RESULT(8,23)
      CR_RFREE_OBS = RESULT(9,23)
      CR_RFREE_CUT = RESULT(10,23)
      RFAC_FREE_P  = RESULT(15,21)
      RFREE        = RESULT(21,10)
      RF_REST      = RESULT(15,10)
      NOREST       = RESULT(16,10)
c      NO_USED      = RESULT(14,10)
      NO_USED = 0
      L_NO_USED = (NO_USED .GT. 0)
      IF (L_DEBUG_PRINT) L_NO_USED = .TRUE.
      CR_NREF_REP = RESULT(14,23)
      L_NREF_REP = (CR_NREF_REP .GT. 0)
      IF (L_DEBUG_PRINT) L_NREF_REP = .TRUE.
      L_RFREE = (RFAC_FREE_P .NE. 0) .OR. (RFREE .NE. 0)
      IF (L_DEBUG_PRINT) L_RFREE = .TRUE.
      NFREE      = RESULT(21,31)
      L_NFREE = NFREE .NE. 0
      IF (L_DEBUG_PRINT) L_NFREE = .TRUE.
      NREST      = RESULT(17,10)
      ERR_MAX    = RESULT(17,21)
      ERR_MIN    = RESULT(14,21)
      DPI_VAL    = RESULT(18,21)
      NOMIT      = RESULT(21,19)
      SIGMAB     = RESULT(12,18)
      SCALE_PATT = RESULT(11,20)
      BADD_PATT  = RESULT(12,20)
      NACT       = RESULT(2,10)
      RMUL       = RESULT(11,15)
      NMUL       = RESULT(12,15)
      NMULT      = RESULT(13,15)
      L_RMUL     = NMULT .NE. 0
      IF (L_DEBUG_PRINT) L_RMUL = .TRUE.

      IPST         = RESULT(1,42)
      PERSCENT_PST = RESULT(2,42)
      SPST(1)      = RESULT(3,42)
      SPST(2)      = RESULT(4,42)
      SPST(3)      = RESULT(5,42)

      NHTEST     = RESULT(1,43)
      IMODE_TWIN = RESULT(2,43)
      ALPHA_TWIN = RESULT(3,43)
      TOL_TWIN   = RESULT(4,43)
      IJ = 4
      DO I=1,3
      DO J=1,3
        IJ = IJ + 1
        ISM_TWIN(I,J) =  RESULT(IJ,43)
      ENDDO
 10   ENDDO
      CALL SYM2SYMB(ISM_TWIN,SOP)
      DO I=1,20
        FHTEST(I)    = RESULT(I,44)
        FHTEST(20+I) = RESULT(I,45)
      ENDDO
      FHTEST(41) = RESULT(21,45)

      READ(MT,ERR=900) RESULTO

      CLOSE(MT)
      RETURN

 900  CONTINUE
      CALL MSGERR(MDOC,' ERR: READ INPUT_FILE_RESULT')
      IERR =1
      CLOSE(MT)
      RETURN

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE INITPS  -  Initialize the PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE INITPS (IERR)

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_version.fh'

      INTEGER IERR
      REAL*4 YL, XCENTR

C      CALL PSNAME (FILPS,ILEN,IPLOT)

C  --- Open and Initialize the PostScript file

      CALL PSFUNIT (51)
      CALL PSOPEN (FILPS,BBOXX1,BBOXX2,BBOXY1,BBOXY2,MXCOLR,
     +     RGB,.FALSE.,1,IERR)

C  --- Place main title
      XCENTR = XORIGN + XMWID + XSEP / 2.0
      YL = YORIGN + 3.0 * YMWID + 2.0 * YSEP

      CALL PSLWID (0.1)

C ---
      CALL PSTEXT (BBOXX1+15.0 , YL+66.0, 9.0,
     *  '"Judge not, that you be not judged" Bible, Matthew, ch.7')

      CALL PSCTXT (XCENTR, YL+51.0, 25.0, 'Structure Factor Check')
      CALL PSCTXT (XCENTR, YL+26.0, 20.0, CODE_NDB)
C ---

C      CALL PSCTXT (XCENTR, YL+56.0, 30.0, 'Structure Factor Check')
C      CALL PSCTXT (XCENTR, YL+26.0, 25.0, CODE_NDB)

      CALL PSTEXT (1.0*BBOXX1+3.0, BBOXY1+3.0, 4.0, 'SFCHECK '//VERSNO)

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE TEXTTPS  -  Write textual info to the PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE TEXTPS(DCORR)

      INCLUDE 'sfch_graph.inc'

      REAL  DCORR

      REAL*4 YL, YL0, XL, XL0, YO, YI, XR, XR0, YR0, XTAB, XTAB2, XTAB3
      REAL*4 XTAB0, XTAB01
      REAL*4 XTAB_4, XTAB_5, XTAB_6
      REAL*4 YHSF, BETWEENBOX, YHMVSF, YHCR, YHMO, AROUNDBOX, YHBB
      REAL*4 YHLE, YHRI, YHGE, YHRE, YRGE, YLGE, YRCR, YLCR
      REAL*4 YRMO, YLMO, YRRE, YLRE, YRSF, YLSF, YRMVSF, YLMVSF
      CHARACTER TEXT*80, TEXH*80, LINE*160, ARING5*5
      CHARACTER TEMP*10, TEM1*10, TEM2*10, TNHOH*10, THATOM*10
      
      INTEGER*4 TS, TE, US, UE, VS, VE, LN 
      INTEGER RMB
C     INTEGER NBA
      INTEGER I

      LOGICAL NULL_STRING
C
      CHARACTER*100 HTMLITAL
C
      INCLUDE 'sfch_comt.fh'
C    -
      YI = 12.0
      BETWEENBOX = 5.0
      AROUNDBOX = 5.0
C  ---
      XTAB = 140.0
      XTAB2 = XTAB + 30.0
      XTAB3 = XTAB2 + 20.0
      XTAB0 = 15.0
      XTAB01 = 30.0

C    - Define boxes sizes

      YHSF = 107.0 + 4*YI + (YI-2.0) + 5.0
      IF(NA.LE.0) THEN 
        YHSF = 107.0 + 5*YI + (YI-2.0) + 5.0
        IF(IPST.GT.0) YHSF = YHSF + YI
        IF(NHTEST.GT.0.AND.
     *    ALPHA_TWIN.GT.0.05.AND.ALPHA_TWIN.LT.0.45) THEN
          YHSF = YHSF + YI*2.0
        ENDIF
      ENDIF

      IF (L_RSTAND) YHSF = YHSF + 3*YI
c      IF (L_NBAD) YHSF = YHSF + YI
      IF (L_NBAD_ABS) YHSF = YHSF + YI
      IF (L_NBA) YHSF = YHSF + YI
      IF (L_NOUT) YHSF = YHSF + YI
      IF (L_COMPL) YHSF = YHSF + YI
      IF (L_RMRG) YHSF = YHSF + YI + (YI-2.0)
      IF (L_RMUL) YHSF = YHSF + YI + (YI-2.0)
      IF (L_NC_OVER) YHSF = YHSF + YI + (YI-2.0)

      YHMVSF = 83.0
c      YHMVSF = YHMVSF + 5*YI + 3.0
      YHMVSF = YHMVSF + 4*YI + 3*(YI-2.0) + 3.0
      IF (L_RFREE) YHMVSF = YHMVSF + 3*YI
      IF (L_NFREE) YHMVSF = YHMVSF + YI
      IF (L_NC_ANISO) YHMVSF = YHMVSF + 2*YI + (YI-2.0)

      YHCR = 70.0
      IF (L_NCS) YHCR = YHCR + 2*YI + 3.0

c      YHMO = 83.0 + YI
      YHMO = 83.0 - YI
      IF (L_SOLV) YHMO = YHMO + YI
      IF (L_ANISO) YHMO = YHMO + YI
      IF (L_CMATT) YHMO = YHMO + YI*2

      YHGE = 42.0
      IF (NLTITLE.NE.0) YHGE = YHGE + (NLTITLE-1)*YI

      YHRE = 83.0
      IF (L_CODE_NDB) THEN
         YHGE = YHGE + YI
         YHRE = YHRE + YI
      ENDIF
      IF (L_NREF_REP) THEN
         YHRE = YHRE + YI
      ENDIF
      IF (L_RES) THEN
         YHRE = YHRE + YI
      ENDIF

C    - Adjust boxes sizes
      IF (L_NA .AND. L_NRFLS) THEN
         YHLE = (YHCR+YHMO+YHRE+BETWEENBOX)
         YHRI = (YHSF+YHMVSF)
         IF (YHLE .GT. YHRI) THEN
            YHMVSF = YHMVSF + (YHLE - YHRI)/2
            YHSF = YHSF + (YHLE - YHRI)/2
            YHBB = YHLE + YHGE + 3*AROUNDBOX + 3*BETWEENBOX
         ELSE
            YHMO = YHMO + (YHRI - YHLE)/3
            YHCR = YHCR + (YHRI - YHLE)/3
            YHRE = YHRE + (YHRI - YHLE)/3
            YHBB = YHRI + YHGE + 3*AROUNDBOX + 3*BETWEENBOX
         ENDIF
      ELSE IF (L_NRFLS) THEN
         YHLE = YHCR
         YHRI = YHSF
         IF (YHCR .GT. YHSF) THEN
            YHSF = YHCR
         ELSE
            YHCR = YHSF
         ENDIF
         YHBB = YHCR + YHGE + 3*AROUNDBOX + 2*BETWEENBOX
      ELSE
         YHLE = (YHCR+YHMO+YHRE+BETWEENBOX)
         YHBB = YHLE + YHGE + 3*AROUNDBOX + 3*BETWEENBOX
      ENDIF

C    - DRAW THE BOXES
C    - Background box
c      XL0 = 65.0
c      XR0 = 520.0
      XL0 = 63.0
      XR0 = 518.0
C      YR0 = 715.0
C      YR0 = 712.0
C     Vertical position of upper edge of box
      YR0 = 600.0
      YL0 = YR0 - YHBB
      IF (YL0 .LT. (BBOXY1+30.0)) THEN
         YL0 = BBOXY1 + 30.0
         YR0 = YL0 + YHBB
      ENDIF
      CALL PSLWID (1.0)
      CALL PSHBOX(XL0,XR0,YL0,YR0,0.75)

C    - General Info box
c      XL = 80.0
c      XR = 505.0
      XL = XL0 + 15.0
      XR = XR0 - 15.0
      YRGE = YR0 - 2*AROUNDBOX
      YLGE = YRGE - YHGE
      CALL PSHBOX(XL,XR,YRGE,YLGE,0.95)

C    - Crystal box
c      XL = 70.0
c      XR = 290.0
      XL = XL0 + 5.0
      XR = XL + 220.0
C      YR = YR0 - AROUNDBOX
c      YR = YR0 - 2*AROUNDBOX - YHGE - 2*BETWEENBOX
      YRCR = YLGE - 2*BETWEENBOX
      YLCR = YRCR - YHCR
      CALL PSHBOX(XL,XR,YRCR,YLCR,0.95)

C    - Model box
      IF (L_NA) THEN
         YRMO = YLCR - BETWEENBOX
         YLMO = YRMO - YHMO
         CALL PSHBOX(XL,XR,YRMO,YLMO,0.95)
      ENDIF

C    - Refinement box
      IF (L_NA) THEN
         YRRE = YLMO - BETWEENBOX
         YLRE = YRRE - YHRE
         CALL PSHBOX(XL,XR,YRRE,YLRE,0.95)
      ENDIF

C    - Second column
c      XL = 295.0
c      XR = 515.0
      XL = XL0 + 230.0
      XR = XL + 220.0
C    - Structure Factors box
      IF (L_NRFLS) THEN
C      YR = YR0 - AROUNDBOX
C         YR = YR0 - 2*AROUNDBOX - YHGE - 2*BETWEENBOX
         YRSF = YLGE - 2*BETWEENBOX
         YLSF = YRSF - YHSF
         CALL PSHBOX(XL,XR,YRSF,YLSF,0.95)
      ENDIF

C    - Model vs Structure Factors box
      IF (L_NA .AND. L_NRFLS) THEN
         YRMVSF = YLSF - BETWEENBOX
         YLMVSF = YRMVSF - YHMVSF
         CALL PSHBOX(XL,XR,YRMVSF,YLMVSF,0.95)
      ENDIF

C  --- Print information in the different boxes

C  --- GENERAL
c      YO = YR0 - AROUNDBOX - 10.0
      YO = YRGE - 10.0
      YL = 0.0
c      XL = 90.
      XL = XL0 + 25.0
C  --- 
c      CALL HTMLTABLE (.TRUE.)
c      CALL HTMLTABLE (.FALSE.)
      CALL PSTEXT (XL, YO-YL, 9.0, 'Title:')
      IF (TITLE_FLAG) THEN
c         CALL HTMLROW2T (HTMLITAL('Title'),' ')
         DO I = 1, NLTITLE
            LINE = TITLINE(I)
c            CALL HTMLTEXT (LINE)
            CALL RMPARENTTEXT (LINE)
            CALL TRIM(LINE,TS,TE)
            CALL PSTEXT (XL+50.0, YO-YL, 9.0, LINE(TS:TE))
            YL = YL + YI
         ENDDO
      ELSE
c         CALL HTMLROW2T (HTMLITAL('Title'),NDB_TITLE)
         CALL LENSTR_BL(NDB_TITLE,LN)
         IF(LN.GT.0) THEN         
           CALL RMPARENTTEXT (NDB_TITLE)
           CALL PSTEXT (XL+50.0, YO-YL, 9.0,NDB_TITLE)
         ENDIF  
         YL = YL + YI
      ENDIF

      CALL PSTEXT (XL, YO-YL, 9.0, 'Date:')
      CALL PSTEXT (XL+50.0, YO-YL, 9.0,NDB_DATE)
c      CALL HTMLROW2T (HTMLITAL('Date'),NDB_DATE)
      CALL LENSTR_BL(NDB_DATE,LN)
      IF(LN.GT.0) THEN         
        IF (L_CODE_NDB) THEN
           YL = YL + YI
           CALL PSTEXT (XL, YO-YL, 9.0, 'NDB code:')
           CALL PSTEXT (XL+50.0, YO-YL, 9.0,CODE_NDB)
c         CALL HTMLROW2T (HTMLITAL('NDB code'),CODE_NDB)
        ENDIF
      ENDIF
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 9.0, 'PDB code:')
      CALL PSTEXT (XL+50.0, YO-YL, 9.0,CODE)
c      CALL HTMLROW2T (HTMLITAL('PDB code'),CODE)
c      CALL HTMLETABLE

c      CALL STARTHTMLRESULTS

c      CALL HTMLCENTER
c      CALL HTMLTABLE (.TRUE.)
C  --- CRYSTAL
c      YO = YR0 - AROUNDBOX - YHGE - BETWEENBOX - 10.0
      YO = YRCR - 10.0
      YL = 0.0
c      XL = 80.
      XL = XL0 + 15.0
      IF(NC_OVER.LT.0) THEN
        IF(EVAL3.GT.0.001) THEN
          CALL PSBTEXT (XL+50.0,YO-YL, 12.0,'Mirror Map')
        ELSE
          CALL PSBTEXT (XL+50.0,YO-YL, 12.0,'Map')
        ENDIF
      ELSE
        CALL PSBTEXT (XL+50.0,YO-YL, 12.0,'Crystal')
      ENDIF
c      CALL HTML2COL (' ')
c      CALL HTMLINDENT
c      CALL HTMLH2('Crystal')
c      CALL HTMLUNINDENT
C  --- Cell parameters output
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Cell parameters:')
c      CALL HTML2COL ( 'Cell parameters:')
      WRITE (TEXT,'(A,F7.2,1X,A)') 'a: ',CELL(1), ARING
      YL = YL + YI
      CALL PSTEXT (XL+10.0, YO-YL, 10.0,
     +     TEXT)
      WRITE (TEXT,'(A,F7.2,1X,A)') 'b: ',CELL(2), ARING
      CALL PSTEXT (XL+75.0, YO-YL, 10.0,
     +     TEXT)
      WRITE (TEXT,'(A,F7.2,1X,A)') 'c: ',CELL(3), ARING
      CALL PSTEXT (XL+140.0, YO-YL, 10.0, TEXT)
      WRITE (TEXT,'(3(A,F7.2,1X,A))') 'a: ',CELL(1), HARING,
     +     '; b: ',CELL(2), HARING, '; c: ',CELL(3), HARING
c      CALL HTMLINDENT
c      CALL HTMLTEXT (TEXT)
      YL = YL + YI

      CALL PSSYMB (XL+10.0, YO-YL, 10.0, 'a:')
      WRITE (TEXT,'(F7.2)') CELL(4)
      CALL PSTEXT (XL+20.0, YO-YL, 10.0, TEXT)
      CALL PSSYMB (XL+75.0, YO-YL, 10.0, 'b:')
      WRITE (TEXT,'(F7.2)') CELL(5)
      CALL PSTEXT (XL+85.0, YO-YL, 10.0, TEXT)
      CALL PSSYMB (XL+140.0, YO-YL, 10.0, 'g:')
      WRITE (TEXT,'(F7.2)') CELL(6)
      CALL PSTEXT (XL+150.0, YO-YL, 10.0, TEXT)

c      CALL PSSYMB (XL+10.0, YO-YL, 10.0, 'a:')
c      WRITE (TEXT,'(F7.2,A)') CELL(4), DEGREE
c      CALL PSTEXT (XL+20.0, YO-YL, 10.0, TEXT)
c      CALL PSSYMB (XL+75.0, YO-YL, 10.0, 'b:')
c      WRITE (TEXT,'(F7.2,A)') CELL(5), DEGREE
c      CALL PSTEXT (XL+85.0, YO-YL, 10.0, TEXT)
c      CALL PSSYMB (XL+140.0, YO-YL, 10.0, 'g:')
c      WRITE (TEXT,'(F7.2,A)') CELL(6), DEGREE
c      CALL PSTEXT (XL+150.0, YO-YL, 10.0, TEXT)

      WRITE (TEXT,'(3(A,F7.2,A))') 'alpha: ', CELL(4), HDEGREE,
     +     '; beta: ', CELL(5), HDEGREE, '; gamma: ', CELL(6), HDEGREE
c      CALL HTMLNLTEXT(TEXT)
c      CALL HTMLUNINDENT
C  ---
      CALL LENSTR_BL(SPGR,LN)
      IF(LN.GT.11) LN=11
      WRITE (TEXT,'(A,A)') 'Space group: ', SPGR(1:LN)
      YL = YL + YI + 3.0
      CALL PSTEXT (XL, YO-YL, 10.0, TEXT)
c      CALL HTML2COL (TEXT)
      IF(NC_OVER.LT.0) THEN
         WRITE (TEXT,'(A,F6.3)') 'Map scale factor:',EVAL1
         YL = YL + YI + 3.0
         CALL PSTEXT (XL, YO-YL, 10.0, TEXT)
      ENDIF
C  ---
      IF (L_NCS) THEN
         WRITE (TEXT,'(A,I6)') 'Number of NCS-operators:',NCS
         YL = YL + YI + 3.0
         CALL PSTEXT (XL, YO-YL, 10.0, TEXT)
c         CALL HTML2COL (TEXT)
         YL = YL + (YI-2.0)
         IF (IGIVEN.NE.0) THEN
            CALL PSTEXT (XL+10.0, YO-YL,8.0,
     +     'use NCS-operators to restore asymm. part of unit cell')
c            CALL HTMLNLTEXT (
c     +     'use NCS-operators to restore asymm. part of unit cell')
         ELSE
            CALL PSTEXT (XL+10.0, YO-YL,8.0,
     +           'NC-symmetry only for information')
c            CALL HTMLNLTEXT ('NC-symmetry only for information')
         ENDIF
      ENDIF

C  --- MODEL
C  --- Title
      IF (L_NA) THEN
c      YO = YR0 - YHCR - AROUNDBOX - YHGE - 10.0 - 2*BETWEENBOX
         YO = YRMO - 10.0
         YL = 0.0
         CALL PSBTEXT (XL+50.0, YO-YL, 12.0,'Model')
c         CALL HTML2COL (' ')
c         CALL HTML2COL (' ')
c         CALL HTMLINDENT
c         CALL HTMLH2('Model')
c         CALL HTMLUNINDENT
C  ---
         WRITE (TEMP,'(I10)') NA
         IF ((NHATOM .EQ. 0) .AND. (NAHOH .EQ. 0)) THEN
            TEXT = TEMP(RMB(TEMP):10)//' atoms'
         ELSE IF (NHATOM .EQ. 0) THEN
            WRITE (TNHOH,'(I10)') NAHOH
            TEXT = TEMP(RMB(TEMP):10)// ' atoms' // ' ('//
     +           TNHOH(RMB(TNHOH):10)//' water molecules)'
         ELSE IF (NAHOH.EQ.0) THEN
            WRITE (THATOM,'(I10)') NHATOM
            TEXT = TEMP(RMB(TEMP):10)// ' atoms' // ' ('//
     +           THATOM(RMB(THATOM):10)//' H atoms)'
         ELSE
            WRITE (TNHOH,'(I10)') NAHOH
            WRITE (THATOM,'(I10)') NHATOM
            TEXT = TEMP(RMB(TEMP):10)// ' atoms' // ' ('//
     +           THATOM(RMB(THATOM):10)//' H atoms, ' //
     +           TNHOH(RMB(TNHOH):10)//' water molecules)'
         ENDIF
         YL = YL + YI + 5.0
         CALL PSTEXT (XL, YO-YL, 10.0, TEXT)
c         CALL HTML2COL (TEXT)
C  ---
         IF (L_ANISO) THEN
            YL = YL + YI
            CALL PSTEXT (XL, YO-YL, 10.0, 
     +      'Number of atoms with aniso_U: ')
            WRITE (TEXT,'(I6)') NANISO
            CALL TRIM(TEXT,TS,TE)
            CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c            CALL HTMLROW2T ('Number of atoms with aniso_U', TEXT)
         ENDIF
C  ---
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Number of chains: ')
         WRITE (TEXT,'(I3)') NCHAIN
         CALL TRIM(TEXT,TS,TE)
         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Number of chains:', TEXT)
c         CALL HTMLROW2T ('Number of chains', TEXT)
C  ---
         IF (L_SOLV) THEN
            YL = YL + YI
            CALL PSTEXT (XL, YO-YL, 10.0,
     +           'Volume not occupied by model: ')
            WRITE (TEXT,'(F4.1,A)') SOLV,' %'
            CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT)
c            CALL HTMLROW2T ('Volume not occupied by model:', TEXT)
c            CALL HTMLROW2T ('Volume not occupied by model', TEXT)
         ENDIF
C  ---
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, '<B> (for atomic model):')

         ARING5 = ARING

         WRITE (TEXT,'(F8.1,1X,A,A)') BAVER, ARING5(1:1),'^2'
c         WRITE (TEXT,'(F8.1,1X,A,A)') BAVER, ARING, TWOSUPERIOR

         WRITE (TEXH,'(F8.1,1X,A,A)') BAVER, HARING, HTWOSUPERIOR
         CALL TRIM(TEXT,TS,TE)
         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T (HANGLELEFT//'B'//HANGLERIGHT//
c     +        ' (for atomic model):', TEXH)
c     +        ' (for atomic model)', TEXH)
C  ---
         YL = YL + YI
         CALL PSSYMB (XL, YO-YL, 10.0, 's')
         CALL PSTEXT (XL+6.0, YO-YL, 10.0, '(B):')

         ARING5 = ARING

         WRITE (TEXT,'(F8.2,1X,A,A)') SIGMAB, ARING5(1:1),'^2'
c         WRITE (TEXT,'(F8.2,1X,A,A)') SIGMAB, ARING, TWOSUPERIOR

         WRITE (TEXH,'(F8.2,1X,A,A)') SIGMAB, HARING, HTWOSUPERIOR
         CALL TRIM(TEXT,TS,TE)
         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('sigma(B):', TEXH)
c         CALL HTMLROW2T ('sigma(B)', TEXH)
C  ---
         IF (L_CMATT) THEN
            YL = YL + YI
            CALL PSTEXT (XL, YO-YL, 10.0, 'Matthews coefficient:')
            WRITE (TEXT,'(F8.2)') CMATTHEWS
            CALL TRIM(TEXT,TS,TE)
            CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c            CALL HTMLROW2T ('Matthews coefficient',TEXT)
            YL = YL + YI
            CALL PSTEXT (XL, YO-YL, 10.0, 'Corresponding solvent % :')
            WRITE (TEXT,'(F8.2)') SOLVENT 
            CALL TRIM(TEXT,TS,TE)
            CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c            CALL HTMLROW2T ('Corresponding solvent %',TEXT)
         ENDIF
C  ---
c         YL = YL + YI
c         CALL PSTEXT (XL, YO-YL, 10.0, 'Reported resolution: ')
c         IF (CR_RES_MAX .NE. 0) THEN
c            IF (CR_RES_MIN .EQ. 0) THEN
c               WRITE (TEXT,'(A,F5.2,1X,A)') 'N.A. - ',CR_RES_MAX, ARING
c            ELSE
c               WRITE (TEXT,'(F5.2,A,F5.2,1X,A)') CR_RES_MIN,' - ',
c     +              CR_RES_RMAX, ARING
c            ENDIF
c         ELSE  IF (RES_REPORT .NE. 0.0) THEN
c            WRITE (TEXT,'(F5.2,1X,A)') RES_REPORT, ARING
c         ELSE
c            WRITE (TEXT,'(A)') 'N.A.'
c         ENDIF
c         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
C  ---
c         YL = YL + YI
c         CALL PSTEXT (XL, YO-YL, 10.0, 'Reported R-factor: ')
c         IF (RFAC_REPORT .EQ. 0.0) THEN
c            WRITE (TEXT,'(A)') 'N.A.'
c         ELSE
c            WRITE (TEXT,'(F5.3)') RFAC_REPORT
c         ENDIF
c         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))

C  --- REFINEMENT
C  --- Title
c      YO = YR0 - YHCR - AROUNDBOX - YHGE - YHMO - 10.0 - 3*BETWEENBOX
         YO = YRRE - 10.0
         YL = 0.0
         CALL PSBTEXT (XL+50.0, YO-YL, 12.0,'Refinement')
c         CALL HTML2COL (' ')
c         CALL HTML2COL (' ')
c         CALL HTMLINDENT
c         CALL HTMLH2('Refinement')
c         CALL HTMLUNINDENT
C  ---
         YL = YL + YI + 5.0
         CALL PSTEXT (XL, YO-YL, 10.0, 'Program:')
         IF (NULL_STRING(CR_PROGRAM)) THEN
            CALL PSTEXT (XL+XTAB, YO-YL, 10.0, 'N.A.')
c            CALL HTMLROW2T ('Program:','N.A.')
c            CALL HTMLROW2T ('Program','N.A.')
         ELSE
            CALL PSJTXT (XL+XTAB+45.0, YO-YL, 10.0, CR_PROGRAM)
c            CALL HTMLROW2T ('Program:',CR_PROGRAM)
c            CALL HTMLROW2T ('Program',CR_PROGRAM)
         ENDIF
C  ---
         YL = YL + YI
         IF (CR_RES_RMAX .NE. 0) THEN
c            CALL PSTEXT (XL, YO-YL, 10.0, 'Resolution range: ')
            CALL PSTEXT (XL, YO-YL, 10.0, 'Nominal resolution range: ')
            IF (CR_RES_RMIN .EQ. 0) THEN
               WRITE (TEXT,'(A,F5.2,1X,A)') 'N.A. - ',CR_RES_RMAX, ARING
               WRITE (TEXH,'(A,F5.2,1X,A)') 'N.A. - ',CR_RES_RMAX,HARING
            ELSE
               WRITE (TEXT,'(F5.1,A,F5.2,1X,A)') CR_RES_RMIN,' - ',
     +              CR_RES_RMAX, ARING
               WRITE (TEXH,'(F5.1,A,F5.2,1X,A)') CR_RES_RMIN,' - ',
     +              CR_RES_RMAX, HARING
            ENDIF
         ELSE
c            CALL PSTEXT (XL, YO-YL, 10.0, 'Reported resolution: ')
            CALL PSTEXT (XL, YO-YL, 10.0,
     +           'Reported nominal resolution: ')
            IF (RES_REPORT .NE. 0.0) THEN
               WRITE (TEXT,'(F5.2,1X,A)') RES_REPORT, ARING
               WRITE (TEXH,'(F5.2,1X,A)') RES_REPORT, HARING
            ELSE
               WRITE (TEXT,'(A)') 'N.A.'
               WRITE (TEXH,'(A)') 'N.A.'
            ENDIF
         ENDIF
         CALL TRIM(TEXT,TS,TE)
         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Resolution range:',TEXH)
c         CALL HTMLROW2T ('Resolution range',TEXH)
c         CALL HTMLROW2T ('Nominal resolution range',TEXH)
C  ---
         IF (L_RES) THEN
            YL = YL + YI
c            CALL PSTEXT (XL, YO-YL, 10.0, 'Reported resolution: ')
            CALL PSTEXT (XL, YO-YL, 10.0,
     +           'Reported nominal resolution: ')
            WRITE (TEXT,'(F5.2,1X,A)') RES_REPORT, ARING
            CALL TRIM(TEXT,TS,TE)
c            CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
            CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c            CALL HTMLROW2T ('Reported resolution:',TEXT)
c            CALL HTMLROW2T ('Reported resolution',TEXT)
c            CALL HTMLROW2T ('Reported nominal resolution',TEXT)
         ENDIF
C  ---
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Reported R-factor: ')
         IF (CR_RFAC_CUT .NE. 0.0) THEN
            WRITE (TEXT,'(F5.3)') CR_RFAC_CUT
         ELSE IF (CR_RFAC_OBS .NE. 0.0) THEN
            WRITE (TEXT,'(F5.3)') CR_RFAC_OBS
         ELSE IF (CR_RFAC_ALL .NE. 0.0) THEN
            WRITE (TEXT,'(F5.3)') CR_RFAC_ALL
         ELSE
            WRITE (TEXT,'(A)') 'N.A.'
         ENDIF
         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Reported R-factor:',TEXT)
c         CALL HTMLROW2T ('Reported R-factor',TEXT)
C  ---
         IF (L_NREF_REP) THEN
            YL = YL + YI
            CALL PSTEXT (XL, YO-YL, 10.0, 'Number of reflections used:')
            WRITE (TEXT,*) CR_NREF_REP
            CALL TRIM(TEXT,TS,TE)
c            CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
            CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c            CALL HTMLROW2T ('Number of reflections used:',TEXT)
c            CALL HTMLROW2T ('Number of reflections used',TEXT)
         ENDIF
C  ---
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Reported Rfree: ')
         IF (CR_RFREE_CUT .NE. 0.0) THEN
            WRITE (TEXT,'(F5.2)') CR_RFREE_CUT
         ELSE IF (CR_RFREE_OBS .NE. 0.0) THEN
            WRITE (TEXT,'(F5.2)') CR_RFREE_OBS
         ELSE IF (CR_RFREE_ALL .NE. 0.0) THEN
            WRITE (TEXT,'(F5.2)') CR_RFREE_ALL
         ELSE
            WRITE (TEXT,'(A)') 'N.A.'
         ENDIF
         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Reported Rfree:',TEXT)
c         CALL HTMLROW2T ('Reported Rfree',TEXT)
C  ---
         YL = YL + YI
         IF (CR_SIGMAR_F .NE. 0.0) THEN
c            TEXH = 'Sigma cut-off (F):'
            TEXH = 'Sigma cut-off (F)'
            CALL PSTEXT (XL, YO-YL, 10.0, 'Sigma cut-off (F): ')
            WRITE (TEXT,'(F5.2)') CR_SIGMAR_F
         ELSE IF (CR_SIGMAR_I .NE. 0.0) THEN
c            TEXH = 'Sigma cut-off (I):'
            TEXH = 'Sigma cut-off (I)'
            CALL PSTEXT (XL, YO-YL, 10.0, 'Sigma cut-off (I): ')
            WRITE (TEXT,'(F5.2)') CR_SIGMAR_I
         ELSE
c            TEXH = 'Sigma cut-off:'
            TEXH = 'Sigma cut-off'
            CALL PSTEXT (XL, YO-YL, 10.0, 'Sigma cut-off: ')
            WRITE (TEXT,'(A)') 'N.A.'
         ENDIF
         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T (TEXH, TEXT)
C     ENDIF corresponding to IF (L_NA) at start of Model section
      ENDIF
C  ---
C  --- STRUCTURE FACTOR
C  ---
      IF (L_NRFLS) THEN
c         XL = 305.0
         XL = XL0 + 230.0 + 10.0
C      YO = YR0 - AROUNDBOX - 10.0
c      YO = YR0 - AROUNDBOX - YHGE - BETWEENBOX - 10.0
      YO = YRSF - 10.0
      YL = 0.0
C  --- Title
      CALL PSBTEXT (XL+20.0, YO-YL, 12.0,'Structure Factors')
c      CALL HTML2COL (' ')
c      CALL HTML2COL (' ')
c      CALL HTMLINDENT
c      CALL HTMLH2('Structure Factors')
c      CALL HTMLUNINDENT
C  ---
      YL = YL + YI + 5.0
      CALL PSBTEXT (XL + 10.0, YO-YL, 10.0, 'Input')
c      CALL HTMLH4('Input')
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Nominal resolution range: ')
c     +     'Resolution range (for input data): ')
      WRITE (TEXT,'(F5.1,A,F5.2,1X,A)') RSMIN,' - ',RSMAX, ARING
      WRITE (TEXH,'(F5.1,A,F5.2,1X,A)') RSMIN,' - ',RSMAX, HARING
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Resolution range (for input data):', TEXH)
c      CALL HTMLROW2T ('Resolution range (for input data)', TEXH)
c      CALL HTMLROW2T ('Nominal resolution range', TEXH)
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'Reflections in file:')
      WRITE (TEXT,*) N_INPUT
      CALL TRIM(TEXT,TS,TE)
c      CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
c      CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
      CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Reflections in file:', TEXT)
c      CALL HTMLROW2T ('Reflections in file', TEXT)
C  ---
      IF (L_RMRG) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0,
     +    'R_merge (merging sym. related reflect.):')
         WRITE (TEXT,'(F5.3)') RMRG
         TEXH = TEXT
         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
         YL = YL + (YI-2.0)
         WRITE (TEMP,'(I10)') NMRG
         CALL TRIM(TEMP,TS,TE)
         WRITE (TEM1,'(I10)') NMRGT
         CALL TRIM(TEM1,US,UE)
         WRITE (TEXT,'(A,A,A,A)') 'reflections: ', TEM1(US:UE),
     +    ' -> ', TEMP(TS:TE)
         CALL TRIM(TEXT,TS,TE)
         CALL PSTEXT (XL+25.0, YO-YL, 9.0, TEXT(TS:TE))
c         CALL HTMLROW
c         CALL HTMLCELL ('R_merge (merging sym. related reflect.)')
c         CALL HTMLNLTEXT (TEXT)
c         CALL HTMLCELL (TEXH)
      ENDIF
C  ---
      IF (L_RMUL) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0,
     +    'R_mult (removing duplicated reflect.):')
         WRITE (TEXT,'(F5.3)') RMUL
         TEXH = TEXT
         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
         YL = YL + (YI-2.0)
         WRITE (TEMP,'(I10)') NMUL
         CALL TRIM(TEMP,TS,TE)
         WRITE (TEM1,'(I10)') NMULT
         CALL TRIM(TEM1,US,UE)
         WRITE (TEXT,'(A,A,A,A)') 'reflections: ', TEM1(US:UE),
     +    ' -> ', TEMP(TS:TE)
         CALL TRIM(TEXT,TS,TE)
         CALL PSTEXT (XL+25.0, YO-YL, 9.0, TEXT(TS:TE))
c         CALL HTMLROW
c         CALL HTMLCELL ('R_mult (removing duplicated reflect.)')
c         CALL HTMLNLTEXT (TEXT)
c         CALL HTMLCELL (TEXH)
      ENDIF
C  ---
      YL = YL + YI
c      CALL PSTEXT (XL, YO-YL, 10.0, 'Acceptable reflections:')
      CALL PSTEXT (XL, YO-YL, 10.0, 'Unique reflections')
      CALL PSTEXT (XL+80.0, YO-YL, 10.0, 'above 0:')
      WRITE (TEXT,*)  NRFLS
      CALL TRIM(TEXT,TS,TE)
c      CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
      CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Unique reflections above 0:',TEXT)
c      CALL HTMLROW2T ('Unique reflections above 0',TEXT)
C  ---
      IF (L_RSTAND) THEN
         YL = YL + YI
c         CALL PSTEXT (XL, YO-YL, 10.0,'Reflections with I>')
         CALL PSTEXT (XL+80.0, YO-YL, 10.0,'above 1')
c         CALL PSSYMB (XL+78.0, YO-YL, 10.0, 's:')
         CALL PSSYMB (XL+112.0, YO-YL, 10.0, 's:')
         WRITE (TEXT,*)  N_GT_SIG
         CALL TRIM(TEXT,TS,TE)
c         CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Unique reflections above 1sigma:',TEXT)
c         CALL HTMLROW2T ('Unique reflections above 1sigma',TEXT)
C  ---
         YL = YL + YI
c         CALL PSTEXT (XL, YO-YL, 10.0,'Reflections with I>3')
         CALL PSTEXT (XL+80.0, YO-YL, 10.0,'above 3')
c         CALL PSSYMB (XL+82.0, YO-YL, 10.0, 's:')
         CALL PSSYMB (XL+112.0, YO-YL, 10.0, 's:')
         WRITE (TEXT,*)  N_GT_3SIG
         CALL TRIM(TEXT,TS,TE)
c         CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Unique reflections above 3sigma:',TEXT)
c         CALL HTMLROW2T ('Unique reflections above 3sigma',TEXT)
      ENDIF
C  ---
      IF (L_NBAD_ABS) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0,
     +        'Reflections systematically absent:')
         WRITE (TEXT,*) NBAD_ABS
         CALL TRIM(TEXT,TS,TE)
c         CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Reflections systematically absent:',TEXT)
c         CALL HTMLROW2T ('Reflections systematically absent',TEXT)
      ENDIF
      IF (L_NBA) THEN
         YL = YL + YI
c         CALL PSTEXT (XL, YO-YL, 10.0, 'Reflections <= 0:')
         CALL PSTEXT (XL, YO-YL, 10.0, 'Reflections     0:')
         CALL PSSYMB (XL+50.0, YO-YL, 10.0, LESSEQUAL)
         WRITE (TEXT,*) NBAD_SD
         CALL TRIM(TEXT,TS,TE)
c         CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Reflections <= 0:',TEXT)
c         CALL HTMLROW2T ('Reflections <= 0',TEXT)
      ENDIF
C  ---
      YL = YL + YI + 5.0
      CALL PSBTEXT (XL + 10.0, YO-YL, 10.0, 'SFCHECK')
c      CALL HTML2COL (' ')
c      CALL HTMLH4('SFCHECK')
C  ---
      YL = YL + YI
c      CALL PSTEXT (XL, YO-YL, 10.0, 'Resolution range: ')
      CALL PSTEXT (XL, YO-YL, 10.0, 'Nominal resolution range: ')
      WRITE (TEXT,'(F5.1,A,F5.2,1X,A)') RES_MIN,' - ',RES_MAX, ARING
      WRITE (TEXH,'(F5.1,A,F5.2,1X,A)') RES_MIN,' - ',RES_MAX, HARING
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
      YL = YL + (YI-2.0)
      WRITE (TEXT,'(A)') '(max. from input data, min. from author)'
      CALL RMPARENTTEXT (TEXT)
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+25.0, YO-YL, 8.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Resolution range:', TEXH)
c      CALL HTMLROW2T ('Resolution range', TEXH)
c      CALL HTMLROW2T ('Nominal resolution range', TEXH)
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'Used reflections:')
      WRITE (TEXT,*)  NACT
      CALL TRIM(TEXT,TS,TE)
c      CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
      CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Used reflections:', TEXT)
c      CALL HTMLROW2T ('Used reflections', TEXT)
C  ---
      IF (L_NOUT) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Reflections out of resolution:')
         WRITE (TEXT,*) NOUT
         CALL TRIM(TEXT,TS,TE)
c         CALL PSJTXT (XL+XTAB+20.0, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Reflections out of resolution:', TEXT)
c         CALL HTMLROW2T ('Reflections out of resolution', TEXT)
      ENDIF
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'Completeness: ')
      WRITE (TEXT,'(F5.1,A)') COMPL,' %'
      CALL TRIM(TEXT,TS,TE)
c      CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Completeness:', TEXT)
c      CALL HTMLROW2T ('Completeness', TEXT)
C  ---
      IF (L_RSTAND) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'R_stand(F) = <')
         CALL PSSYMB (XL+62.0, YO-YL, 10.0, 's')
         CALL PSTEXT (XL+68.0, YO-YL, 10.0, '(F)>/<F> : ')
         TEXH = 'R_stand(F) = '//HANGLELEFT//'sigma(F)'//HANGLERIGHT//
c     +        '/'//HANGLELEFT//'(F)'//HANGLERIGHT//' :'
     +        '/'//HANGLELEFT//'(F)'//HANGLERIGHT
         WRITE (TEXT,'(F5.3)') RSTAND
         CALL TRIM(TEXT,TS,TE)
c         CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T(TEXH, TEXT)
      ENDIF
C  ---
      IF (L_NC_OVER) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Anisotropic distribution of Structure Factors ')
         YL = YL + (YI-2.0)
         CALL PSTEXT (XL+XTAB0, YO-YL, 10.0,
     +     'ratio of eigen values: ')
         WRITE (TEXT,'(3F8.4)') EVAL1,EVAL2,EVAL3  
         CALL TRIM(TEXT,TS,TE)
         XTAB_4 = 105.0
         CALL PSTEXT (XL+XTAB_4, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW
c         CALL HTMLCELL ('Anisotropic distribution of Structure Factors')
c         CALL HTMLINDENT
c         CALL HTMLNLTEXT ('ratio of eigen values')
c         CALL HTMLUNINDENT
c         CALL HTMLCELL ('  ')
         WRITE (TEXT,'(F8.4)') EVAL1
c         CALL HTMLNLTEXT (TEXT)
         WRITE (TEXT,'(F8.4)') EVAL2
c         CALL HTMLNLTEXT (TEXT)
         WRITE (TEXT,'(F8.4)') EVAL3  
c         CALL HTMLNLTEXT (TEXT)
      ENDIF
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'B_overall (by Patterson): ')

      ARING5 = ARING

      WRITE (TEXT,'(F5.0,A,A)') BOVERALL, ARING5(1:1),'^2'
c      WRITE (TEXT,'(F5.0,A,A)') BOVERALL, ARING, TWOSUPERIOR

      WRITE (TEXH,'(F5.0,A,A)') BOVERALL, HARING, HTWOSUPERIOR
c     WRITE (TEXT,'(F4.1,1X,A,A)') BOVERALL, ARING, TWOSUPERIOR
c     WRITE (TEXH,'(F4.1,1X,A,A)') BOVERALL, HARING, HTWOSUPERIOR
      CALL TRIM(TEXT,TS,TE)
c      CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('B_overall (by Patterson):', TEXH)
c      CALL HTMLROW2T ('B_overall (by Patterson)', TEXH)
C  ---
      YL = YL + YI
c      CALL PSTEXT (XL, YO-YL, 10.0, 'Effective resolution: ')
      CALL PSTEXT (XL, YO-YL, 10.0, 'Optical resolution: ')
      WRITE (TEXT,'(F5.2,1X,A)') RESEFF, ARING
      WRITE (TEXH,'(F5.2,1X,A)') RESEFF, HARING
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Effective resolution:', TEXH)
c      CALL HTMLROW2T ('Effective resolution', TEXH)
c      CALL HTMLROW2T ('Optical resolution', TEXH)
C  ---
      IF (L_COMPL) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Expected opt. resol. for complete data set: ')
c     +     'Expected eff. resol. for complete data set: ')
         WRITE (TEXT,'(F6.2,1X,A)') RESEFF_COMP, ARING
         WRITE (TEXH,'(F6.2,1X,A)') RESEFF_COMP, HARING
         CALL TRIM(TEXT,TS,TE)
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Expected eff. resol. for complete data set:'
c         CALL HTMLROW2T ('Expected eff. resol. for complete data set'
c         CALL HTMLROW2T ('Expected opt. resol. for complete data set'
c     +        , TEXH)
      ENDIF
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'Estimated minimal error:')
      WRITE (TEXT,'(F5.3,1X,A)') ERR_MIN, ARING
      WRITE (TEXH,'(F5.3,1X,A)') ERR_MIN, HARING
      CALL TRIM(TEXT,TS,TE)
c      CALL PSTEXT (XL+XTAB, YO-YL, 10.0, TEXT(TS:TE))
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Estimated minimal error:', TEXH)
c      CALL HTMLROW2T ('Estimated minimal error', TEXH)
C     ENDIF corresponding to IF (L_NRFLS) at start of Structure factor section
      ENDIF
C ---
      IF(NA.LE.0) THEN
        IF(IPST.LE.0) THEN 
          YL = YL + YI
          CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Pseudo-translation is not detected')
        ELSE
          YL = YL + YI
          WRITE (TEXT,'(A,F5.1,A)') 
     +     'Pseudo-translation is detected:',PERSCENT_PST,' %'
          CALL TRIM(TEXT,TS,TE)
          CALL PSTEXT (XL, YO-YL, 10.0, TEXT(TS:TE))
          YL = YL + YI
          CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Pseudo-translation vector:')
          WRITE (TEXT,'(3F7.3)') 
     *    SPST(1),SPST(2),SPST(3)  
          CALL TRIM(TEXT,TS,TE)
          XTAB_4 = 125.0
          CALL PSTEXT (XL+XTAB_4, YO-YL, 10.0, TEXT(TS:TE))
        ENDIF


        IF(NHTEST.GT.0.AND.
     *    ALPHA_TWIN.GT.0.05.AND.ALPHA_TWIN.LT.0.45) THEN
          YL = YL + YI
          CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Probably crystal is twinned')
          YL = YL + YI
          CALL PSTEXT (XL, YO-YL, 10.0,
     +     'Twinning fraction:')
          WRITE (TEXT,'(F6.3)') ALPHA_TWIN   
          CALL TRIM(TEXT,TS,TE)
          XTAB_4 = 105.0
          CALL PSTEXT (XL+XTAB_4, YO-YL, 10.0, TEXT(TS:TE))  
        ENDIF

      ENDIF

C  ---
C  --- Model vs Structure factors
C  --- Title
      IF (L_NA .AND. L_NRFLS) THEN
      YO = YRMVSF - 10.0
      YL = 0.0
      CALL PSBTEXT (XL+20.0, YO-YL, 12.0,
     +     'Model vs. Structure Factors')
c      CALL HTML2COL (' ')
c      CALL HTML2COL (' ')
c      CALL HTMLINDENT
c      CALL HTMLH2('Model vs. Structure Factors')
c      CALL HTMLUNINDENT
C  ---
      YL = YL + YI + 5.0
      CALL PSTEXT (XL, YO-YL, 10.0, 'R-factor for all reflections: ')
      WRITE (TEXT,'(F5.3)') RFAC
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)
c      CALL HTMLROW2T ('R-factor for all reflections', TEXT)
CC  ---

      IF(NC_OVER.LT.0) THEN
        RCORR = DCORR
      ENDIF
      YL = YL + YI
      IF(NC_OVER.LT.0) THEN
        CALL PSTEXT (XL, YO-YL, 10.0, 'Map Correlation   : ')
C        WRITE (TEXT,'(F5.3)') DCORR_TOT
C        CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)
      ELSE
        CALL PSTEXT (XL, YO-YL, 10.0, 'Correlation factor: ')
C        WRITE (TEXT,'(F5.3)') RCORR
C        CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)
      ENDIF
        WRITE (TEXT,'(F5.3)') RCORR
        CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)

c      CALL HTMLROW2T ('Correlation factor:', TEXT)
c      CALL HTMLROW2T ('Correlation factor', TEXT)
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'R-factor:')
      WRITE (TEXT,'(F5.3)') RFACS
      TEXH = TEXT
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)
c      CALL HTMLROW2T ('R-factor:', TEXT)
c      CALL HTMLROW2T ('R-factor', TEXT)
c      CALL HTMLROW
c      CALL HTMLCELL ('R-factor')
C  ---
c      YL = YL + YI
c      IF (SIGL .GE. 10.0) THEN
c         WRITE (TEXT,'(A,F3.0)') '(for F >', SIGL
c      ELSE
c         WRITE (TEXT,'(A,F3.1)') '(for F >', SIGL
c      ENDIF
c      CALL RMPARENTTEXT (TEXT)
c      CALL TRIM(TEXT,TS,TE)
c      CALL PSTEXT (XL+20.0,YO-YL, 8.0, TEXT(TS:TE))
c      CALL PSSYMB (XL+56.0,YO-YL, 8.0, 's')
c      WRITE (TEMP,'(F5.1)') RESNL
c      CALL TRIM(TEMP,TS,TE)
c      WRITE (TEM1,'(F5.1)') RESXL
c      CALL TRIM (TEM1,US,UE)
c      WRITE (TEM2,'(I10)') NREST
c      CALL TRIM (TEM2,VS,VE)
c      TEXT = ', resol. '//TEMP(TS:TE)//' - '
c     +     //TEM1(US:UE)//ARING//', and '//TEM2(VS:VE)//
c     +     ' reflexions)'
c      CALL RMPARENTTEXT (TEXT)
c      CALL PSTEXT (XL+61.0,YO-YL, 8.0, TEXT)
      YL = YL + (YI-2.0)
c      CALL PSTEXT (XL+25.0,YO-YL, 9.0, 'for')
      CALL PSTEXT (XL+XTAB0,YO-YL, 9.0, 'for')
      IF (SIGL .GE. 10.0) THEN
         WRITE (TEXT,'(A,F3.0)') 'F > ', SIGL
      ELSE
         WRITE (TEXT,'(A,F3.1)') 'F > ', SIGL
      ENDIF
      CALL TRIM(TEXT,TS,TE)
c      CALL PSTEXT (XL+40.0,YO-YL, 9.0, TEXT(TS:TE))
c      CALL PSSYMB (XL+67.0,YO-YL, 9.0, 's')
      CALL PSTEXT (XL+XTAB01,YO-YL, 9.0, TEXT(TS:TE))
      CALL PSSYMB (XL+XTAB01+27.0,YO-YL, 9.0, 's')
c      CALL HTMLINDENT
c      CALL HTMLNLTEXT (TEXT(TS:TE)//'sigma')
      YL = YL + (YI-2.0)
c      CALL PSTEXT (XL+40.0,YO-YL, 9.0, 'resolution range: ')
      CALL PSTEXT (XL+XTAB01,YO-YL, 9.0, 'nom. resolution range: ')
      WRITE (TEMP,'(F6.2)') RESNL
      CALL TRIM(TEMP,TS,TE)
      WRITE (TEM1,'(F6.2)') RESXL
      CALL TRIM (TEM1,US,UE)
c      TEXT = TEMP(TS:TE)//' - '//TEM1(US:UE)//ARING
      TEXT = TEMP(TS:TE)//' - '//TEM1(US:UE)
      CALL TRIM(TEXT,TS,TE)
c      CALL PSTEXT (XL+110.0,YO-YL, 9.0, TEXT)
      CALL PSTEXT (XL+120.0,YO-YL, 9.0, TEXT(TS:TE)//ARING)
c      CALL HTMLNLTEXT ('resolution range: ')
c      CALL HTMLNLTEXT ('nom. resolution range: ')
c      CALL HTMLTEXT (TEXT(TS:TE)//HARING)
      YL = YL + (YI-2.0)
c      CALL PSTEXT (XL+40.0,YO-YL, 9.0, 'reflections used: ')
      CALL PSTEXT (XL+XTAB01,YO-YL, 9.0, 'reflections used: ')
      WRITE (TEM2,'(I10)') NREST
      CALL TRIM (TEM2,VS,VE)
c      CALL PSTEXT (XL+110.0,YO-YL, 9.0, TEM2(VS:VE))
      CALL PSTEXT (XL+120.0,YO-YL, 9.0, TEM2(VS:VE))
c      CALL HTMLNLTEXT ('reflections used: ')
c      CALL HTMLTEXT (TEM2)
c      CALL HTMLUNINDENT
c      CALL HTMLCELL (TEXH)
C  ---
      IF (L_RFREE) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Rfree: ')
         IF (RFAC_FREE_P .EQ. 0) THEN
            WRITE (TEXT,'(F5.3)') RFAC_FREE_P
         ELSE
            WRITE (TEXT,'(F5.3)') RFREE
         ENDIF
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)
c         CALL HTMLROW2T ('Rfree:', TEXT)
c         CALL HTMLROW2T ('Rfree', TEXT)
      ENDIF
C  ---
      IF (L_NFREE) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Nfree:')
         WRITE (TEXT,*) NFREE
         CALL TRIM(TEXT,TS,TE)
         CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Nfree:', TEXT)
c         CALL HTMLROW2T ('Nfree', TEXT)
      ENDIF
C  ---
      IF (L_RFREE) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'R-factor without free-refl.:')
         WRITE (TEXT,'(F5.3)') RF_REST
         CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)
c         CALL HTMLROW2T ('R-factor without free-refl.:', TEXT)
c         CALL HTMLROW2T ('R-factor without free-refl.', TEXT)
C  ---
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Non free-reflections:')
         WRITE (TEXT,*) NOREST
         CALL TRIM(TEXT,TS,TE)
         CALL PSJTXT (XL+XTAB3, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW2T ('Non free-reflections:', TEXT)
c         CALL HTMLROW2T ('Non free-reflections', TEXT)
      ENDIF
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0,
     +     '<u> (error in coords by Luzzati plot): ')
      WRITE (TEXT,'(F5.3,1X,A)') RMSL, ARING
      WRITE (TEXH,'(F5.3,1X,A)') RMSL, HARING
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT)
c      CALL HTMLROW2T (HANGLELEFT//'u'//HANGLERIGHT//
c     +     '(error in coords by Luzzati plot):', TEXH)
C     +     '(error in coords by Luzzati plot)', TEXH)
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'Estimated maximal error:')
      WRITE (TEXT,'(F5.3,1X,A)') ERR_MAX, ARING
      WRITE (TEXH,'(F5.3,1X,A)') ERR_MAX, HARING
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Estimated maximal error:', TEXH)
c      CALL HTMLROW2T ('Estimated maximal error', TEXH)
C  ---
      YL = YL + YI
      IF(NC_OVER.LT.0) THEN
        CALL PSTEXT (XL, YO-YL, 10.0, 'Resolution_used:')
        WRITE (TEXT,'(F5.2,1X,A)') EVAL2, ARING
      ELSE
        CALL PSTEXT (XL, YO-YL, 10.0, 'DPI:')
        WRITE (TEXT,'(F5.3,1X,A)') DPI_VAL, ARING
        WRITE (TEXH,'(F5.3,1X,A)') DPI_VAL, HARING
      ENDIF
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('DPI:', TEXH)
c      CALL HTMLROW2T ('DPI', TEXH)
C  ---
      YL = YL + YI + 3.0
      CALL PSBTEXT (XL + 20.0, YO-YL, 10.0, 'Scaling')
c      CALL HTML2COL (' ')
c      CALL HTMLH4 ('Scaling')
C  ---
      YL = YL + YI
      CALL PSTEXT (XL, YO-YL, 10.0, 'Scale:')
      WRITE (TEXT,'(F8.3,1X)') SCALE_PATT
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Scale:', TEXT)
c      CALL HTMLROW2T ('Scale', TEXT)
C  ---
      YL = YL + YI
C     CALL PSTEXT (XL, YO-YL, 10.0, 'Badd:')
      CALL PSTEXT (XL, YO-YL, 10.0, 'Bdiff:')
      WRITE (TEXT,'(F8.2,1X)') BADD_PATT
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+XTAB2, YO-YL, 10.0, TEXT(TS:TE))
c      CALL HTMLROW2T ('Badd:', TEXT)
c      CALL HTMLROW2T ('Bdiff', TEXT)
C  ---
      IF (L_NC_ANISO) THEN
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Anisothermal Scaling (Beta):')
         YL = YL + (YI-2.0)
c         WRITE (TEXT,'(6F9.4)') B11,B22,B33,B12,B13,B23
         WRITE (TEXT,'(6F8.4)') B11,B22,B33,B12,B13,B23
         CALL TRIM(TEXT,TS,TE)
c         XTAB_5 = 0 
         XTAB_5 = 10.0 
         CALL PSTEXT (XL+XTAB_5, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW
c         CALL HTMLCELL ('Anisothermal Scaling (Beta)')
         WRITE (TEXT,'(F8.4)') B11
c         CALL HTMLCELL (TEXT)
         WRITE (TEXT,'(F8.4)') B22
c         CALL HTMLNLTEXT (TEXT)
         WRITE (TEXT,'(F8.4)') B33
c         CALL HTMLNLTEXT (TEXT)
         WRITE (TEXT,'(F8.4)') B12
c         CALL HTMLNLTEXT (TEXT)
         WRITE (TEXT,'(F8.4)') B13
c         CALL HTMLNLTEXT (TEXT)
         WRITE (TEXT,'(F8.4)') B23
c         CALL HTMLNLTEXT (TEXT)
C  ---
         YL = YL + YI
         CALL PSTEXT (XL, YO-YL, 10.0, 'Solvent correction - Ks,Bs:')
         WRITE (TEXT,'(F8.3,1X,F8.3)') CKSOL,BSOL
         CALL TRIM(TEXT,TS,TE)
         XTAB_6 = 120.0
         CALL PSTEXT (XL+XTAB_6, YO-YL, 10.0, TEXT(TS:TE))
c         CALL HTMLROW
c         CALL HTMLCELL ('Solvent correction - Ks,Bs')
         WRITE (TEXT,'(F8.3)') CKSOL
c         CALL HTMLCELL (TEXT)
         WRITE (TEXT,'(F8.3)') BSOL
c         CALL HTMLNLTEXT (TEXT)
      ENDIF

C     ENDIF corresponding to IF (L_NA .AND. L_NRFLS) at start of section
      ENDIF

 100  CONTINUE

c      CALL HTMLETABLE
c      CALL HTMLECENTER
c      CALL HTMLCLOSE

      END

C-----------------------------------------------------------------------
C
C RMB - Find first non blank character in a string
C
C-----------------------------------------------------------------------

      INTEGER FUNCTION RMB (S)
      CHARACTER S*(*)
      INTEGER LEN, I

      LENGTH = LEN(S)

      DO I = 1, LENGTH
         IF (S(I:I) .NE. ' ') THEN
            RMB = I
            RETURN
         ENDIF
      ENDDO

      END

C-----------------------------------------------------------------------
C
C RMPARENTTEXT - Replace parentheses in text string
C
C-----------------------------------------------------------------------

      SUBROUTINE RMPARENTTEXT (LINE)

      CHARACTER LINE*(*), TNAME*200
      INTEGER*4 I,J,L

      J = 1
      I = 1
      L = LEN(LINE)
 1000 CONTINUE
         IF (LINE(I:I).EQ.'(') THEN
            IF (J.LT.(L-2)) THEN
               TNAME(J:J+3) = '\\050'
               J = J + 4
            ELSE
               TNAME(J:L) = ' '
            ENDIF
         ELSE IF (LINE(I:I).EQ.')') THEN
            IF (J.LT.(L-2)) THEN
               TNAME(J:J+3) = '\\051'
               J = J + 4
            ELSE
               TNAME(J:L) = ' '
            ENDIF
         ELSE
            TNAME(J:J) = LINE(I:I)
            J = J + 1
         ENDIF
         I = I + 1
      IF (J.LE.L) GOTO 1000

      LINE = TNAME

      END

C-----------------------------------------------------------------------
C
C NULL_STRING  -  Check if a string is null
C
C-----------------------------------------------------------------------

      LOGICAL FUNCTION NULL_STRING (S)
      CHARACTER S*(*)

      IF ((S(1:1) .EQ. ' ') .OR.
     +    (S(1:1) .EQ. '?') .OR.
     +    (S(1:1) .EQ. '.')) THEN
          NULL_STRING = .TRUE.
      ELSE
          NULL_STRING = .FALSE.
      ENDIF

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE LUZZATIPS  -  Create the Luzzati plot PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE LUZZATIPS

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW
      REAl*4 X1, X2, YL1, YL2, YR1, YR2, YF1, YF2
      REAL*4 XWMIN, XWMAX, XWWID, YWWID
      REAL*4 XVEC(20)
      CHARACTER TEXT*80
      INTEGER*4 I, NGY
      REAL*4 AY,AX
      INTEGER*4 TS, TE
      LOGICAL L_RFREEP
C  --- 
      XW = 150.0
c      XL = XORIGN
c      XL = 229.0
c      XL = 344.0
      XL = 0.0
      XR = XL + XW
      YW = 150.0
c      YL = YLOWBOX
c      YL = YLOWBOX - 2*YSIZREG
      YL = 0.0
      YR = YL + YW

      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XL,YL,XL,YR,XR,YR,XR,YL)
C     Title is now written at the end of the subroutine on a background mask
C      CALL PSCTXT((XR+XL)/2.0,YL+140.0,13.0,'R-factor')
      CALL PSRTXT(XL-30.0,YL+60.0,15.0,'R-factor')

C      XWMIN = 1/RESVEC(1)
      XWMIN = 0.0
      XWMAX = 1/RESVEC(21)
      I = (10*XWMAX + 1.0)
      XWMAX = I/10.0
      XWWID = XWMAX - XWMIN

      IF (RFAC .GT. 0.4) THEN
         YWWID = 1.0
         NGY = 5
      ELSE
         YWWID = 0.60
         NGY = 6
      ENDIF

      CALL AXES(XL,XR,YL,YR,NGAPX,NGY,
     +     XWMIN,XWMAX,0.0,YWWID,
     +     10.0,2,1,15.0,.TRUE.,.TRUE.,
     +     .FALSE.,.FALSE.,.FALSE.,.FALSE.)

C     Labels along X axis
      DO I=1,NGAPX
         WRITE (TEXT,'(F6.2)') 1/(XWWID/NGAPX*I)
         CALL TRIM(TEXT,TS,TE)
c         CALL PSCTXT(XL+XW/NGAPX*I,YL-25.0,10.0,TEXT(TS:TE))
         CALL PSCTXT(XL+XW/NGAPX*I,YL-20.0,10.0,TEXT(TS:TE))
      ENDDO

      CALL PSCTXT(XL+XW*1.15,YL-20.0,10.0,ARING)
      CALL PSCTXT (XL-30.0,YL-7.5,13.0,'1/d')
      CALL PSCTXT (XL-30.0,YL-20.0,13.0,'d')

      DO I=1,20
         XVEC(I) = (1/RESVEC(I) + 1/RESVEC(I+1))/2
      ENDDO

C     Draw the Luzzati Plot
      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      YL2 = YL + LUZVEC(1)/YWWID*YW
      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YL1= YL2
         YL2 = YL + LUZVEC(I+1)/YWWID*YW
         IF (LUZVEC(I).NE.0.0) THEN
            CALL PSLINE (X1, YL1, X2, YL2)
         ENDIF
      ENDDO

C     Draw the R-factor Plot
      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      YR2 = YL + RFACVC(1)/YWWID*YW
      YF2 = YL + FREVEC(1)/YWWID*YW

      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YR1 = YR2
         YR2 = YL + RFACVC(I+1)/YWWID*YW
c         YF1 = YF2
c         YF2 = YL + FREVEC(I+1)/YWWID*YW

         IF (RFACVC(I+1).GT.YWWID) THEN
            YR2= YL + YW
            AY = (YWWID-RFACVC(I))/(RFACVC(I+1)-RFACVC(I))
            AX = (XVEC(I)+(XVEC(I+1)-XVEC(I))*AY)
            X2 = XL + (AX - XWMIN)/XWWID*XW
         ENDIF

         IF (RFACVC(I).GT.YWWID) THEN
            YR1 = YL + YW
            AY = (YWWID-RFACVC(I))/(RFACVC(I+1)-RFACVC(I))
            AX = (XVEC(I)+(XVEC(I+1)-XVEC(I))*AY)
            X1 = XL + (AX - XWMIN)/XWWID*XW
         ENDIF

         CALL PSLWID (2.0)
         IF ((YR1.NE.YR2).OR.(X1.NE.X2)) THEN
            CALL PSLINE (X1, YR1, X2, YR2)
         ENDIF
         IF (RFACVC(I).LT.YWWID) THEN
            CALL PSCIRC(X1,YR1,MRAD)
         ENDIF

      ENDDO
      CALL PSCIRC(X2,YR2,MRAD)

c      L_RFREEP = .FALSE.

      L_RFREEP =  L_RFREE

      IF (L_RFREEP) THEN

      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      YF2 = YL + FREVEC(1)/YWWID*YW

      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
c         YR1 = YR2
c         YR2 = YL + RFACVC(I+1)/YWWID*YW
         YF1 = YF2
         YF2 = YL + FREVEC(I+1)/YWWID*YW

         IF (FREVEC(I+1).GT.YWWID) THEN
            YF2= YL + YW
            AY = (YWWID-FREVEC(I))/(FREVEC(I+1)-FREVEC(I))
            AX = (XVEC(I)+(XVEC(I+1)-XVEC(I))*AY)
            X2 = XL + (AX - XWMIN)/XWWID*XW
         ENDIF

         IF (FREVEC(I).GT.YWWID) THEN
            YF1 = YL + YW
            AY = (YWWID-FREVEC(I))/(FREVEC(I+1)-FREVEC(I))
            AX = (XVEC(I)+(XVEC(I+1)-XVEC(I))*AY)
            X1 = XL + (AX - XWMIN)/XWWID*XW
         ENDIF

         CALL PSLWID (1.0)
         IF (((YF1.NE.YF2).OR.(X1.NE.X2)) .AND. 
     +        (FREVEC(I).GT.0))  THEN
            CALL PSLINE (X1, YF1, X2, YF2)
         ENDIF
         IF ((FREVEC(I).LT.YWWID).AND.(FREVEC(I).GT.0)) THEN
            CALL PSMARK(X1,YF1,2,MWIDX,MWIDY)
            L_RFREEP = .TRUE.
         ENDIF
      ENDDO
      ENDIF

      IF (L_RFREEP) CALL PSMARK(X2,YF2,2,MWIDX,MWIDY)

C     Legend
      YL1 = YL - 35.0
      IF (L_RFREEP) THEN
         CALL PSLWID (1.0)
         CALL PSLINE (XL+100.0, YL1, XL+115.0, YL1)
         CALL PSMARK (XL+100.0, YL1,2,MWIDX,MWIDY)
         CALL PSMARK (XL+115.0, YL1,2,MWIDX,MWIDY)
         CALL PSTEXT (XL+125.0, YL1, 9.0,'Rfree')
      ENDIF
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL1, XL+15.0, YL1)
      CALL PSCIRC (XL, YL1, MRAD)
      CALL PSCIRC (XL+15.0, YL1, MRAD)
      CALL PSTEXT (XL+25.0, YL1, 9.0, 'R-factor')
      YL1 = YL - 45.0
      CALL PSLWID (0.6)
      CALL PSLINE (XL, YL1, XL+15.0, YL1)
      WRITE (TEXT,'(A,F5.3)')
     +  'Luzzati plot drawn for an atomic error = ',RMS_L
      CALL PSTEXT (XL+25.0, YL1, 9.0, TEXT)

      CALL PSLWID (0.0)
      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      AX = (XR+XL)/2.0
      CALL PSUBOX(AX-25.0,YL+136.0,AX-25.0,YL+146.0,
     1     AX+25.0,YL+146.0,AX+25.0,YL+136.0)
       CALL PSCTXT(AX,YL+140.0,13.0,'R-factor')

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE WILSONPS  -  Create the Wilson plot PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE WILSONPS

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW
      REAl*4 X1, X2, YL1, YL2, YR1, YR2
      REAL*4 XWMIN, XWMAX, XWWID, YWWID, YMAX
      REAL*4 XVEC(20)
      REAL*4 GAPY
      CHARACTER TEXT*80,ARING5*5
      INTEGER*4 I, NGY
      INTEGER*4 TS, TE
C  --- 
cu      CALL PSTRANSLATE (XORIGN, YLOWBOX)
      XW = 150.0
c      XL = XORIGN
      XL = 0.0
      XR = XL + XW
      YW = 150.0
c      YL = YLOWBOX
      YL = 0.0
      YR = YL + YW

      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XL,YL,XL,YR,XR,YR,XR,YL)
C     Title is now written at the end of the subroutine on a background mask
c      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Wilson Plot')
      CALL PSRTXT(XL-30.0,YL+60.0,15.0,'<F>')

C     Legend
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL-35.0, XL+15.0, YL-35.0)
      CALL PSCIRC(XL, YL-35.0,MRAD)
      CALL PSCIRC(XL+15.0, YL-35.0,MRAD)
      CALL PSTEXT (XL+25.0, YL-35.0, 9.0, '<F>')
      CALL PSLWID (0.6)
      CALL PSLINE (XL, YL-45.0, XL+15.0, YL-45.0)

      ARING5 = ARING
      WRITE (TEXT,'(A,F5.1,1X,A,A,A)')
     +     'Wilson plot (B_overall = ',BOVER, ARING5(1:1),'^2', ')'
c      WRITE (TEXT,'(A,F5.1,1X,A,A,A)')
c     +     'Wilson plot (B_overall = ',BOVER, ARING, TWOSUPERIOR, ')'

      CALL PSTEXT (XL+25.0, YL-45.0, 9.0, TEXT)

C      XWMIN = 1/RESVEC(1)
      XWMIN = 0.0
      XWMAX = 1/RESVEC(21)
      I = (10*XWMAX + 1.0)
      XWMAX = I/10.0
      XWWID = XWMAX - XWMIN

      YMAX = 0
      DO I=1,20
         XVEC(I) = (1/RESVEC(I) + 1/RESVEC(I+1))/2
         IF (FMEVEC(I).GT.YMAX) YMAX = FMEVEC(I)
         IF (BOVVEC(I).GT.YMAX) YMAX = BOVVEC(I)
      ENDDO
C
      GAPY = 10.0**INT(LOG10(YMAX)-1)
      NGY = (YMAX/GAPY) + 1
C     Between 10 and 20 : one tic every 2
      IF (NGY .LE. 20) THEN
         NGY = (NGY+1)/2
         YWWID = GAPY*NGY*2
C     Between 20 amd 40 : one tic every 5
      ELSE IF (NGY .LE. 40) THEN
         NGY = (NGY+4)/5
         YWWID = GAPY*NGY*5
C     Between 40 and 100 : one tic every 10
      ELSE
         NGY = (NGY+9)/10
         YWWID = GAPY*NGY*10
      ENDIF

      CALL AXES(XL,XR,YL,YR,NGAPX,NGY,
     +     XWMIN,XWMAX,0.0,YWWID,
     +     10.0,2,0,15.0,.TRUE.,.TRUE.,
     +     .FALSE.,.FALSE.,.FALSE.,.FALSE.)
      CALL PSCTXT (XL-30.0,YL-7.5,13.0,'1/d')
      CALL PSCTXT (XL-30.0,YL-20.0,13.0,'d')

      DO I=1,NGAPX
         WRITE (TEXT,'(F6.2)') 1/(XWWID/NGAPX*I)
         CALL TRIM(TEXT,TS,TE)
         CALL PSCTXT(XL+XW/NGAPX*I,YL-20.0,10.0,TEXT(TS:TE))
      ENDDO
      CALL PSCTXT(XL+XW*1.15,YL-20.0,10.0,ARING)

      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      YL2 = YL + BOVVEC(1)/YWWID*YW
      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YL1= YL2
         YL2 = YL + BOVVEC(I+1)/YWWID*YW
         IF (BOVVEC(I).GT.0.0) THEN
            CALL PSLINE (X1, YL1, X2, YL2)
         ENDIF
      ENDDO

      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      YR2 = YL + FMEVEC(1)/YWWID*YW
      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YR1 = YR2
         YR2 = YL + FMEVEC(I+1)/YWWID*YW
         CALL PSLWID (2.0)
         IF (FMEVEC(I).GT.0.0) THEN
            CALL PSLINE (X1, YR1, X2, YR2)
            CALL PSCIRC(X1,YR1,MRAD)
         ENDIF
      ENDDO
      CALL PSCIRC(X2,YR2,MRAD)

      CALL PSLWID (0.0)
      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XR-70.0,YL+136.0,XR-70.0,YL+146.0,
     1     XR-5.0,YL+146.0,XR-5.0,YL+136.0)
      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Wilson Plot')

cu      CALL PSTRANSLATE (-XORIGN, -YLOWBOX)

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE EFFECTIVPS  -  Create the Eff. Resol. plot PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE EFFECTIVPS

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW
      REAl*4 X1, X2, YL1, YL2, YR1, YR2
      REAL*4 XWMIN, XWMAX, XWWID, YWWID
      REAL*4 XVEC(20)
      CHARACTER TEXT*80
      INTEGER*4 I, NGY
      INTEGER*4 TS, TE
C  --- 
      XW = 150.0
c      XL = 344.0
      XL = 0.0
      XR = XL + XW
      YW = 150.0
c      YL = YLOWBOX
      YL = 0.0
      YR = YL + YW

      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XL,YL,XL,YR,XR,YR,XR,YL)
C     Title is now written at the end of the subroutine on a background mask
c      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Effective resolution')
      CALL PSTEXT(XL-30.0,YL+90.0,15.0,ARING)

      XWMIN = 0.0
      XWMAX = 1/RESVEC(21)
      I = (10*XWMAX + 1.0)
      XWMAX = I/10.0
      XWWID = XWMAX - XWMIN

      IF(RESEFF.GT.9.0) THEN 
        NGY = 20
        YWWID = 20.0
      ELSE IF(RESEFF.GT.6.0) THEN 
        NGY = 12
        YWWID = 12.0
      ELSE IF(RESEFF.GT.3.0) THEN 
        NGY = 8
        YWWID = 8.0
      ELSE
        NGY = 4
        YWWID = 4.0
      ENDIF

      DO I=1,20
         XVEC(I) = (1/RESVEC(I) + 1/RESVEC(I+1))/2
      ENDDO

      CALL AXES(XL,XR,YL,YR,NGAPX,NGY,
     +     XWMIN,XWMAX,0.0,YWWID,
     +     10.0,2,1,15.0,.TRUE.,.TRUE.,
     +     .FALSE.,.FALSE.,.FALSE.,.FALSE.)

      CALL PSCTXT (XL-30.0,YL-7.5,13.0,'1/d')
      CALL PSCTXT (XL-30.0,YL-20.0,13.0,'d')

      DO I=1,NGAPX
         WRITE (TEXT,'(F6.2)') 1/(XWWID/NGAPX*I)
         CALL TRIM(TEXT,TS,TE)
         CALL PSCTXT(XL+XW/NGAPX*I,YL-20.0,10.0,TEXT(TS:TE))
      ENDDO
      CALL PSCTXT(XL+XW*1.15,YL-20.0,10.0,ARING)

C     Legend
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL-35.0, XL+15.0, YL-35.0)
      CALL PSCIRC(XL, YL-35.0,MRAD)
      CALL PSCIRC(XL+15.0, YL-35.0,MRAD)
      CALL PSTEXT (XL+25.0, YL-35.0, 9.0,
     +     'Optical resolution')
c     +     'Effective resolution')
      CALL PSLWID (0.6)
      CALL PSLINE (XL, YL-45.0, XL+15.0, YL-45.0)
      CALL PSTEXT (XL+25.0, YL-45.0, 9.0,
     +     'Optical resolution for atom with B = 0')
c     +     'Effective resolution for atom with B = 0')

      CALL PSLWID (0.6)
      X2 = XL + (XVEC(5)-XWMIN)/XWWID*XW
      YR2 = YL + EFBVEC(5)/YWWID*YW
      DO I=5,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YR1 = YR2
         YR2 = YL + EFBVEC(I+1)/YWWID*YW
         IF (EFBVEC(I).LT.YWWID) THEN
            CALL PSLINE (X1, YR1, X2, YR2)
         ENDIF
      ENDDO

      CALL PSLWID (2.0)
      X2 = XL + (XVEC(5)-XWMIN)/XWWID*XW
      YL2 = YL + EFFVEC(5)/YWWID*YW
      DO I=5,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YL1= YL2
         YL2 = YL + EFFVEC(I+1)/YWWID*YW
         IF (EFFVEC(I).LT.YWWID) THEN
            CALL PSLINE (X1, YL1, X2, YL2)
            CALL PSCIRC(X1,YL1,MRAD)
         ENDIF
      ENDDO
      CALL PSCIRC(X2,YL2,MRAD)

      CALL PSLWID (0.0)
      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XR-110.0,YL+136.0,XR-110.0,YL+146.0,
     1     XR-5.0,YL+146.0,XR-5.0,YL+136.0)
c      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Effective resolution')
      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Optical resolution')

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE COMPLETEPS  -  Create the Completness plot PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE COMPLETEPS

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW
      REAl*4 X1, X2, YL1, YL2, YR1, YR2
      REAL*4 XWMIN, XWMAX, XWWID, YWWID
      REAL*4 XVEC(20)

      CHARACTER TEXT*80
      INTEGER*4 I, NGY
      INTEGER*4 TS, TE
C  --- 
      XW = 150.0
c      XL = XORIGN
      XL = 0.0
      XR = XL + XW
      YW = 150.0
c      YL = YLOWBOX - YSIZREG
      YL = 0.0
      YR = YL + YW

      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XL,YL,XL,YR,XR,YR,XR,YL)
      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Completeness')

      XWMIN = 0.0
      XWMAX = 1/RESVEC(21)
      I = (10*XWMAX + 1.0)
      XWMAX = I/10.0
      XWWID = XWMAX - XWMIN

      NGY = 6
      YWWID = 1.2

      DO I=1,20
         XVEC(I) = (1/RESVEC(I) + 1/RESVEC(I+1))/2
      ENDDO

      CALL AXES(XL,XR,YL,YR,NGAPX,NGY,
     +     XWMIN,XWMAX,0.0,YWWID,
     +     10.0,2,1,15.0,.TRUE.,.TRUE.,
     +     .FALSE.,.FALSE.,.TRUE.,.FALSE.)

      CALL PSCTXT (XL-30.0,YL-7.5,13.0,'1/d')
      CALL PSCTXT (XL-30.0,YL-20.0,13.0,'d')

      DO I=1,NGAPX
         WRITE (TEXT,'(F6.2)') 1/(XWWID/NGAPX*I)
         CALL TRIM(TEXT,TS,TE)
         CALL PSCTXT(XL+XW/NGAPX*I,YL-20.0,10.0,TEXT(TS:TE))
      ENDDO
      CALL PSCTXT(XL+XW*1.15,YL-20.0,10.0,ARING)

      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      YL2 = YL + COMVEC(1)/YWWID*YW
      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YL1= YL2
         YL2 = YL + COMVEC(I+1)/YWWID*YW
         CALL PSLWID (2.0)
         CALL PSLINE (X1, YL1, X2, YL2)
         CALL PSCIRC(X1,YL1,MRAD)
      ENDDO
      CALL PSCIRC(X2,YL2,MRAD)

      IF (RSTAND.EQ.0) THEN
         RETURN
      ENDIF

      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      YR2 = YL + SIFVEC(1)/YWWID*YW
      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YR1 = YR2
         YR2 = YL + SIFVEC(I+1)/YWWID*YW
         CALL PSLWID (2.0)
         IF (SIFVEC(I).LT.YWWID) THEN
            CALL PSLINE (X1, YR1, X2, YR2)
            CALL PSMARK(X1,YR1,2,MWIDX,MWIDY)
         ENDIF
      ENDDO
      CALL PSMARK(X2,YR2,2,MWIDX,MWIDY)

C     Legend
      YL1 = YL - 35.0
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL1, XL+15.0, YL1)
      CALL PSCIRC(XL, YL1,MRAD)
      CALL PSCIRC(XL+15.0, YL1,MRAD)
      CALL PSTEXT (XL+25.0, YL1, 9.0, 'Completeness')
      YL1 = YL - 45.0
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL1, XL+15.0, YL1)
      CALL PSMARK(XL, YL1,2,MWIDX,MWIDY)
      CALL PSMARK(XL+15.0, YL1,2,MWIDX,MWIDY)
      CALL PSTEXT(XL+25.0,YL1,9.0,'R_stand(F) = <')
      CALL PSSYMB (XL+80.0, YL1, 9.0, 's')
      CALL PSTEXT (XL+85.0, YL1, 9.0, '(F)>/<F>')

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE ERRORPLOTPS  -  Create the Error plot PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE ERRORPLOTPS

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW
      REAl*4 X1, X2, YL1, YL2, YR1, YR2
      REAL*4 XWMIN, XWMAX, XWWID, YWWID
      REAL*4 XVEC(20)
      CHARACTER TEXT*80
      INTEGER*4 I, NGY
      INTEGER*4 TS, TE
C  --- 
      XW = 150.0
c      XL = 344.0
      XL = 0.0
      XR = XL + XW
      YW = 150.0
c      YL = YLOWBOX - YSIZREG
      YL = 0.0
      YR = YL + YW

      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XL,YL,XL,YR,XR,YR,XR,YL)
C     Title is now written at the end of the subroutine on a background mask
C      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Coordinate errors')
      CALL PSTEXT(XL-30.0,YL+100.0,15.0,ARING)

      XWMIN = 0.0
      XWMAX = 1/RESVEC(21)
      I = (10*XWMAX + 1.0)
      XWMAX = I/10.0
      XWWID = XWMAX - XWMIN

      NGY = 5
      YWWID = 0.5

      IF (L_NA) THEN
        IF (ERR_MIN.GT.YWWID.OR.ERR_MAX.GT.YWWID) YWWID = 1.0
      ELSE
        IF (ERR_MIN .GT. YWWID) YWWID = 1.0
      ENDIF

      DO I=1,20
         XVEC(I) = (1/RESVEC(I) + 1/RESVEC(I+1))/2
      ENDDO

      CALL AXES(XL,XR,YL,YR,NGAPX,NGY,
     +     XWMIN,XWMAX,0.0,YWWID,
     +     10.0,2,1,15.0,.TRUE.,.TRUE.,
     +     .FALSE.,.FALSE.,.FALSE.,.FALSE.)

      CALL PSCTXT (XL-30.0,YL-7.5,13.0,'1/d')
      CALL PSCTXT (XL-30.0,YL-20.0,13.0,'d')

      DO I=1,NGAPX
         WRITE (TEXT,'(F6.2)') 1/(XWWID/NGAPX*I)
         CALL TRIM(TEXT,TS,TE)
         CALL PSCTXT(XL+XW/NGAPX*I,YL-20.0,10.0,TEXT(TS:TE))
      ENDDO
      CALL PSCTXT(XL+XW*1.15,YL-20.0,10.0,ARING)

C     Legend
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL-35.0, XL+15.0, YL-35.0)
      CALL PSMARK(XL, YL-35.0,2,MWIDX,MWIDY)
      CALL PSMARK(XL+15.0, YL-35.0,2,MWIDX,MWIDY)
      CALL PSTEXT (XL+25.0, YL-35.0, 9.0,
     +     'Expected maximal coordinate error')
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL-45.0, XL+15.0, YL-45.0)
      CALL PSCIRC(XL, YL-45.0,MRAD)
      CALL PSCIRC(XL+15.0, YL-45.0,MRAD)
      CALL PSTEXT (XL+25.0, YL-45.0, 9.0,
     +     'Expected minimal coordinate error')

      X2 = XL + (XVEC(7)-XWMIN)/XWWID*XW
      YL2 = YL + ER1VEC(7)/YWWID*YW
      DO I=7,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YL1= YL2
         YL2 = YL + ER1VEC(I+1)/YWWID*YW
         CALL PSLWID (2.0)
         IF (ER1VEC(I).LT.YWWID) THEN
            CALL PSLINE (X1, YL1, X2, YL2)
            CALL PSCIRC(X1,YL1,MRAD)
         ENDIF
      ENDDO
      IF (ER1VEC(19).LT.YWWID) THEN
        CALL PSCIRC(X2,YL2,MRAD)
      ENDIF
      IF (L_NA) THEN
        X2 = XL + (XVEC(7)-XWMIN)/XWWID*XW
        YR2 = YL + ER2VEC(7)/YWWID*YW
        DO I=7,19
           X1 = X2
           X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
           YR1 = YR2
           YR2 = YL + ER2VEC(I+1)/YWWID*YW
           CALL PSLWID (2.0)
           IF (ER2VEC(I).LT.YWWID) THEN
              CALL PSLINE (X1, YR1, X2, YR2)
              CALL PSMARK(X1,YR1,2,MWIDX,MWIDY)
           ENDIF
        ENDDO
        IF (ER2VEC(19).LT.YWWID) THEN
          CALL PSMARK(X2,YR2,2,MWIDX,MWIDY)
        ENDIF
      ENDIF

      CALL PSLWID (0.0)
      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XR-100.0,YL+136.0,XR-100.0,YL+146.0,
     1     XR-5.0,YL+146.0,XR-5.0,YL+136.0)
      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Coordinate errors')

      END
C-----------------------------------------------------------------------
C
C SUBROUTINE PTWINPLOTPS  Partial Twinning test
C
C-----------------------------------------------------------------------

      SUBROUTINE PTWINPLOTPS

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW, F
      REAl*4 X1, X2, YL1, YL2, YR1, YR2
      REAL*4 XWMIN, XWMAX, XWWID, YWWID
      REAL*4 XVEC(20)
      CHARACTER TEXT*80
      INTEGER*4 I, NGY , NGX, LEN
      INTEGER*4 TS, TE
C  --- 
      XW = 150.0
      XL = 0.0
      XR = XL + XW
      YW = 150.0
      YL = 0.0
      YR = YL + YW

      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XL,YL,XL,YR,XR,YR,XR,YL)
      CALL PSTEXT(XL-30.0,YL+100.0,15.0,'H')

      XWMIN = 0.0
      XWMAX = 1.0
      XWWID = XWMAX - XWMIN
      NGX   = 5
      NGY   = 5
      YWWID = 1.0

      CALL AXES(XL,XR,YL,YR,NGX,NGY,
     +     XWMIN,XWMAX,0.0,YWWID,
     +     10.0,1,1,15.0,.TRUE.,.TRUE.,
     +     .FALSE.,.FALSE.,.FALSE.,.FALSE.)

c     +     10.0,2,1,15.0,.TRUE.,.TRUE.,

C     Legend
      CALL PSLWID (2.0)
      CALL PSTEXT(XL,YL-20.0,10.0,'Cumulative distribution of H')

      CALL PSTEXT(XL,YL-30.0,10.0,'H = !I(h1)-I(h2)!/(I(h1)+I(h2))')

      CALL LENSTR_BL(SOP,LEN)
      IF(LEN.GT.70) LEN = 70
      TEXT = 'twin-op: '//SOP(1:LEN)
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL, YL-40.0, 9.0,TEXT(TS:TE))
 

      WRITE (TEXT,'(A,I4,5X,F6.3)')'Axis order,  tol: '
     * ,IMODE_TWIN,TOL_TWIN
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL, YL-50.0, 9.0,TEXT(TS:TE))

      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL-60.0, XL+15.0, YL-60.0)
      CALL PSCIRC(XL, YL-60.0,MRAD)
      CALL PSCIRC(XL+15.0, YL-60.0,MRAD)
      WRITE (TEXT,'(A,F6.3)') 'twinning fraction= ',ALPHA_TWIN
      CALL TRIM(TEXT,TS,TE)
      CALL PSTEXT (XL+25.0, YL-60.0, 9.0,TEXT(TS:TE))

      DO I=1,5
        X1  = XL
        X2  = XR
        YL1 = YL
        YL2 = (YR/5.0)*I
        F   = 0.5 - 0.1*I        
        CALL PSLWID (0.6)
        CALL PSLINE (X1, YL1, X2, YL2)
        WRITE (TEXT,'(F3.1)') F 
        CALL TRIM(TEXT,TS,TE)
        CALL PSTEXT (XR+5.0, YL2, 9.0,TEXT(TS:TE))
      ENDDO

      X2  = XL 
      YR2 = YL
      DO I=1,40
        X1 = X2
        X2 = XL + FHTEST(I+1)*XW
        YR1 = YR2
        YR2 = YL + ((YR-YL)/40.0)*I
        CALL PSLWID (2.0)
        CALL PSLINE (X1, YR1, X2, YR2)
        CALL PSCIRC(X1,YR1,MRAD)
      ENDDO

C     CALL PSCIRC(X2,YR2,MRAD)

      CALL PSRTXT(XR+30.0,YL ,10.0,
     * 'Alpha(twinning fraction)= 1/2 - <H>')

      CALL PSLWID (0.0)
      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XR-100.0,YL+136.0,XR-100.0,YL+146.0,
     1     XR-5.0,YL+146.0,XR-5.0,YL+136.0)

      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Partial Twinning Test')

      END
C-----------------------------------------------------------------------
C
C SUBROUTINE TWINPLOTPS  
C
C-----------------------------------------------------------------------

      SUBROUTINE TWINPLOTPS

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW
      REAl*4 X1, X2, YL1, YL2, YR1, YR2
      REAL*4 XWMIN, XWMAX, XWWID, YWMIN, YWMAX, YWWID
      REAL*4 XVEC(20)
      REAL*4 MMRAD, TEMP, TEMPA
      CHARACTER TEXT*80
      INTEGER*4 I, NGY
      INTEGER*4 TS, TE
C  --- 

      IF(IMODE_TWIN.LT.0.0) RETURN

      MMRAD = MRAD/4.0

      XW = 150.0
c      XL = 344.0
      XL = 0.0
      XR = XL + XW
      YW = 150.0
c      YL = YLOWBOX - YSIZREG
      YL = 0.0
      YR = YL + YW

      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XL,YL,XL,YR,XR,YR,XR,YL)
C     Title is now written at the end of the subroutine on a background mask
C      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Coordinate errors')
C      CALL PSTEXT(XL-30.0,YL+100.0,15.0,ARING)

      XWMIN = 0.0
      XWMAX = 1/RESVEC(21)
      I = (10*XWMAX + 1.0)
      XWMAX = I/10.0
      XWWID = XWMAX - XWMIN

      NGY = 4
      YWMIN = 1.0
      YWMAX = 3.0
      YWWID = YWMAX - YWMIN
C      IF (ERR_MAX .GT. YWWID) YWWID = 6.0

      DO I=1,20
         XVEC(I) = (1/RESVEC(I) + 1/RESVEC(I+1))/2
      ENDDO

      CALL AXES(XL,XR,YL,YR,NGAPX,NGY,
     +     XWMIN,XWMAX,YWMIN,YWMAX,
     +     10.0,2,1,15.0,.TRUE.,.TRUE.,
     +     .FALSE.,.FALSE.,.FALSE.,.FALSE.)

      CALL PSCTXT (XL-30.0,YL-7.5,13.0,'1/d')
      CALL PSCTXT (XL-30.0,YL-20.0,13.0,'d')

      DO I=1,NGAPX
         WRITE (TEXT,'(F6.2)') 1/(XWWID/NGAPX*I)
         CALL TRIM(TEXT,TS,TE)
         CALL PSCTXT(XL+XW/NGAPX*I,YL-20.0,10.0,TEXT(TS:TE))
      ENDDO

      CALL PSCTXT(XL+XW*1.15,YL-20.0,10.0,ARING)

C     Legend
      CALL PSLWID (2.0)
      CALL PSLINE (XL, YL-35.0, XL+15.0, YL-35.0)
      CALL PSMARK(XL, YL-35.0,2,MWIDX,MWIDY)
      CALL PSMARK(XL+15.0, YL-35.0,2,MWIDX,MWIDY)

      WRITE (TEXT,'(A,A,A,A)')
     +     'twinning test   <I',TWOSUPERIOR,'>/<I>',TWOSUPERIOR
      CALL PSTEXT (XL+25.0, YL-35.0, 9.0, TEXT)
 
      CALL PSLWID (0.5)
      CALL PSLINE (XL, YL-45.0, XL+15.0, YL-45.0)
C      CALL PSCIRC(XL, YL-45.0,MRAD)
C      CALL PSCIRC(XL+15.0, YL-45.0,MRAD)
      CALL PSTEXT (XL+25.0, YL-45.0, 9.0,
     +     'averaged value')

      CALL PSTEXT (XL, YL-55.0, 9.0,
     +     '2 - untwinned data ;  1.5 - twinned data')

      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
C     YL2 = YL + ER1VEC(7)/YWWID*YW
      TEMPA = ERR_MAX-YWMIN
      IF(TEMPA.LT.  0.0) TEMPA = 0.0
      IF(TEMPA.GT.YWWID) TEMPA = YWWID
      YL2 = YL + TEMPA/YWWID*YW
      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YL1= YL2
C        YL2 = YL + ER1VEC(I+1)/YWWID*YW
         YL2 = YL + TEMPA/YWWID*YW
         CALL PSLWID (0.5)
C         IF (ER1VEC(I).LT.YWWID) THEN
            CALL PSLINE (X1, YL1, X2, YL2)
C           CALL PSCIRC(X1,YL1,MRAD)
C         ENDIF
      ENDDO
C     CALL PSCIRC(X2,YL2,MRAD)

      X2 = XL + (XVEC(1)-XWMIN)/XWWID*XW
      TEMP = ER2VEC(1)-YWMIN
      IF(TEMP.LT.  0.0) TEMP = 0.0
      IF(TEMP.GT.YWWID) TEMP = YWWID
      YR2 = YL + TEMP/YWWID*YW
      DO I=1,19
         X1 = X2
         X2 = XL + (XVEC(I+1)-XWMIN)/XWWID*XW
         YR1 = YR2
         TEMP = ER2VEC(I+1)-YWMIN
         IF(TEMP.LT.  0.0) TEMP = 0.0
         IF(TEMP.GT.YWWID) TEMP = YWWID
         YR2 = YL + TEMP/YWWID*YW
         CALL PSLWID (2.0)
C         IF ( .LT.YWWID) THEN
            CALL PSLINE (X1, YR1, X2, YR2)
            CALL PSMARK(X1,YR1,2,MWIDX,MWIDY)
C         ENDIF
      ENDDO
      CALL PSMARK(X2,YR2,2,MWIDX,MWIDY)

      CALL PSLWID (0.0)
      CALL PSHADE(0.95,COLPLT(1,2),RGB,MXCOLR,.FALSE.)
      CALL PSUBOX(XR-100.0,YL+136.0,XR-100.0,YL+146.0,
     1     XR-5.0,YL+146.0,XR-5.0,YL+136.0)
      CALL PSJTXT(XR-5.0,YL+140.0,13.0,'Perfect Twinning test')

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE STEREOGRAM
C
C-----------------------------------------------------------------------

      SUBROUTINE STEREOGRAM

      INCLUDE 'sfch_graph.inc'

      REAL*4 YL, YR, YW, XL, XR, XW, X2, Y2, BINC
      REAl*4 X1, Y1, RADL, RADH, STANGLE, ENANGLE, ANGLEINC
      REAL*4 SHADE, CRADIUS, THETA, THETAINC, RTH30, RTH60
      INTEGER*4 I,J
c      CHARACTER TEXT*80
      CHARACTER TEXT8*8
      REAL*4 PI2
      PARAMETER (PI2 = 1.570796326795)
C  --- 
      XW = 150.0
c      XL = XORIGN
      XL = 0.0
      XR = XL + XW
      YW = 150.0
c      YL = YLOWBOX - 2*YSIZREG
      YL = 0.0
      YR = YL + YW
      X1 = (XL+XR)/2.0
      Y1 = (YL+YR)/2.0 - 15.0
      CRADIUS = 75.0
C  ---
      THETAINC = 5
      THETA = 0
      RADH = 0.0
      ANGLEINC = 5.0
      ENANGLE = 0.0

c      CALL PSLWID (0.1)
      CALL PSLWID (0.0)
      DO I = 1,18
         RADL = RADH
         THETA = THETA + THETAINC
         RADH = CRADIUS * TAN(PI2*(THETA/2.0)/90.0)
         ENANGLE = 0.0
         DO J = 1,72
            STANGLE = ENANGLE
            ENANGLE = ENANGLE + ANGLEINC
            IF (RESULTO(I,J) .GT. 0) THEN
               SHADE = 2.0 - RESULTO(I,J)
               CALL PSSECTOR (X1,Y1,RADL,RADH,STANGLE,ENANGLE,SHADE)
            ELSE IF (RESULTO(I,J) .EQ. 0) THEN
               CALL PSSECTOR (X1,Y1,RADL,RADH,STANGLE,ENANGLE,1.0)
            ENDIF
         ENDDO
      ENDDO
C     This just to avoid bounding of the last drawn sector - not nice!
      CALL PSSECTOR (X1,Y1,0.0,0.0,STANGLE,ENANGLE,1.0)

      CALL PSLWID (2.0)
C     Theta = 90 (border of the stereogram
      CALL PSCIRCLE (X1,Y1,CRADIUS)
      CALL PSLWID (0.3)
C     Theta = 30 (use tan(Theta/2))
      RTH30 = CRADIUS * TAN(PI2/6.0)
      CALL PSCIRCLE (X1,Y1,RTH30)
C     Theta = 60 (use tan(Theta/2))
      RTH60 = CRADIUS * TAN(PI2/3.0)
      CALL PSCIRCLE (X1,Y1,RTH60)
C     Axes of stereogram
      CALL PSLINE (X1-CRADIUS, Y1, X1+CRADIUS, Y1)
      CALL PSLINE (X1, Y1-CRADIUS, X1, Y1+CRADIUS)
C     Arrow defining the Theta and Phi increasing sense
      CALL PSLWID (1.0)
      CALL PSLINE (X1+CRADIUS, Y1, X1+CRADIUS+10.0, Y1)
      CALL PSARROWHEAD (X1+CRADIUS+10.0, Y1, 0.0, 10.0, 5.0)
      CALL PSBSECTOR (X1,Y1,CRADIUS+10.0,CRADIUS+10.0, 5.0, 15.0, 1.0)
      CALL PSARROWHEAD (X1+COS(PI2*15.0/90.0)*(CRADIUS+10.0),
     +     Y1+SIN(PI2*15.0/90.0)*(CRADIUS+10.0),105.0, 10.0, 5.0)
C     Labels for the axes Theta and Phi
      CALL PSSYMB (X1+CRADIUS+10.0, Y1-10.0, 10.0, 'q')
      CALL PSSYMB (X1+CRADIUS+12.0, Y1+25.0, 10.0, 'j')
C     Labels for circles with Theta = 30, 60, 90
      WRITE (TEXT8,'(I2,A4)') 30, DEGREE
      CALL PSRDTXT (X1+COS(-PI2/2.0)*RTH30-1.0,
     +     Y1+SIN(-PI2/2.0)*RTH30+1.0,5.0,TEXT8(1:6))
      WRITE (TEXT8,'(I2,A4)') 60, DEGREE
      CALL PSRDTXT (X1+COS(-PI2/2.0)*RTH60-1.0,
     +     Y1+SIN(-PI2/2.0)*RTH60+1.0,5.0,TEXT8(1:6))
      WRITE (TEXT8,'(I2,A4)') 90, DEGREE
      CALL PSRDTXT (X1+COS(-PI2/2.0)*CRADIUS-1.5,
     +     Y1+SIN(-PI2/2.0)*CRADIUS+1.5,5.0,TEXT8(1:6))

      CALL PSCTXT (X1, Y1+CRADIUS+30.0, 13.0, 
     +  'Stereographic projection of')
      CALL PSCTXT (X1, Y1+CRADIUS+15.0, 13.0, 
     +  'the averaged radial completeness')

C     H, K, L projection table
      X2 = XL - 50.0
      Y2 = YL - 10.0
      CALL PSTEXT (X2+85.0, Y2-30.0, 8.0,'polar coordinates of the') 
      CALL PSTEXT (X2+85.0, Y2-40.0, 8.0,'crystallographical axes')
      CALL PSLWID (1.5)
      CALL PSHBOX (X2,X2+80.0,Y2,Y2-47.0,1.0)
      CALL PSLWID (0.6)
      CALL PSLINE (X2,Y2-14.0,X2+80.0,Y2-14.0)
      CALL PSLINE (X2+15.0,Y2,X2+15.0,Y2-47.0)
      CALL PSSYMB (X2+30.0, Y2-8.0, 9.0, 'q')
      CALL PSSYMB (X2+60.0, Y2-8.0, 9.0, 'j')
c      CALL PSTEXT (X2+5.0, Y2-20.0, 9.0, 'H')
      CALL PSTEXT (X2+5.0, Y2-20.0, 9.0, 'h')
      WRITE (TEXT8,'(F8.2)') RESULTO(1,73)
      CALL PSJTXT (X2+45.0, Y2-20.0, 9.0, TEXT8)
      WRITE (TEXT8,'(F8.2)') RESULTO(2,73)
      CALL PSJTXT (X2+75.0, Y2-20.0, 9.0, TEXT8)

c      CALL PSTEXT (X2+5.0, Y2-30.0, 9.0, 'K')
      CALL PSTEXT (X2+5.0, Y2-30.0, 9.0, 'k')
      WRITE (TEXT8,'(F8.2)') RESULTO(3,73)
      CALL PSJTXT (X2+45.0, Y2-30.0, 9.0, TEXT8)
      WRITE (TEXT8,'(F8.2)') RESULTO(4,73)
      CALL PSJTXT (X2+75.0, Y2-30.0, 9.0, TEXT8)

c      CALL PSTEXT (X2+5.0, Y2-40.0, 9.0, 'L')
      CALL PSTEXT (X2+5.0, Y2-40.0, 9.0, 'l')
      WRITE (TEXT8,'(F8.2)') RESULTO(5,73)
      CALL PSJTXT (X2+45.0, Y2-40.0, 9.0, TEXT8)
      WRITE (TEXT8,'(F8.2)') RESULTO(9,73)
      CALL PSJTXT (X2+75.0, Y2-40.0, 9.0, TEXT8)

      BINC = 10.0
      X2 = XL - 30.0
      Y2 = YL + 20.0
      CALL PSTEXT (X2-15.0,Y2, 9.0,'0.0')
      CALL PSLWID (1.0)
      DO I = 1, 10
         CALL PSHBOX (X2, X2+BINC, Y2, Y2+BINC, (10-I)*0.1)
         Y2 = Y2 + BINC
      ENDDO
      CALL PSTEXT (X2-15.0,Y2, 9.0,'1.0')
      CALL PSRTXT (X2-20.0,Y2-90.0,10.0,'level of completeness')

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE NEWPAGEPS  -  Create a new page
C
C-----------------------------------------------------------------------

      SUBROUTINE NEWPAGEPS

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_version.fh'

      REAL*4 YL, XCENTR

      CALL PSNWPAG(BBOXX1,BBOXX2,BBOXY1,BBOXY2,MXCOLR,
     +     RGB,.FALSE.,1)

C  --- Place main title
      XCENTR = XORIGN + XMWID + XSEP / 2.0
      YL = YORIGN + 3.0 * YMWID + 2.0 * YSEP

      CALL PSLWID (0.1)

      CALL PSCTXT (XCENTR, YL+56.0, 30.0, 'Structure Factor Check')
      CALL PSCTXT (XCENTR, YL+26.0, 25.0, CODE_NDB)

      CALL PSTEXT (1.0*BBOXX1+3.0, BBOXY1+3.0, 4.0, 'SFCHECK '//VERSNO)

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE FINALPS  -  Finalize the PostScript file
C
C-----------------------------------------------------------------------

      SUBROUTINE FINALPS

      INCLUDE 'sfch_graph.inc'


C  --- Write out end of PostScript file
      CALL PSCLOS(BBOXX1,BBOXX2,BBOXY1,BBOXY2)

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE CUSTOM  -  Perform customization tasks
C
C-----------------------------------------------------------------------
      SUBROUTINE CUSTOM (MDOC,SFCH_FNAME)

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_html.inc'
C      INTEGER LNBLNK
      INTEGER MDOC
      CHARACTER LINE*80,SFCH_FNAME*(*)
      INTEGER*4 TS, TE, LEN, ILN 

      CALL TRIM (CODE_NDB,TS,TE)
C      FILPS = 'sfcheck_' // CODE_NDB(TS:TE) // '.ps'

      CALL LENSTR_BL(SFCH_FNAME,LEN)
      FILPS = SFCH_FNAME(1:LEN)//'_'//CODE_NDB(TS:TE)//'.ps'

C     -- HTML definition

c     CALL GETENV('SFCHECKHTML',LINE)

      LINE = ' '

      CALL LENSTR_BL(LINE,LEN)
      IF (LEN.LE.0) THEN
         HTMLF = .FALSE.
      ELSE
         HTMLF     = .TRUE.
         FILHTML   = CODE_NDB(TS:TE) // '.html'
         FILPLHTML = CODE_NDB(TS:TE) // '_pl.html'
         FILREHTML = CODE_NDB(TS:TE) // '_re.html'
         FILLOHTML = CODE_NDB(TS:TE) // '_lo.html'
      ENDIF
c      ILEN = 15
c      ILEN = LNBLNK(FILPS)
      CALL LENSTR_BL(FILPS,ILEN)
      ILN = ILEN
      IF(ILN.GT.68) ILN=68
      WRITE(LINE,'(''* Plotfile: '',A)') FILPS(1:ILN)
      CALL MSGDOC(MDOC,LINE)

      IPLOT = 0

      END

C-----------------------------------------------------------------------
C
C SUBROUTINE TRIM  -  Remove leading blanks in CHARACTER
C
C-----------------------------------------------------------------------

      SUBROUTINE TRIM (TEXT,TS,TE)

      IMPLICIT NONE
      CHARACTER*(*) TEXT

      INTEGER*4 I1,I2,TS,TE,LL

      LL = LEN(TEXT)

      IF(LL.GT.0) THEN
        DO I1 = 1, LL
           IF (TEXT(I1:I1) .NE. ' ') THEN
              TS = I1
              GOTO 1001
           ENDIF
        ENDDO                 
      ENDIF
      TS = LL
      TE = LL
      TS = 1
      TE = 1
      TEXT(1:1) = '~'

      RETURN
 1001 CONTINUE
      DO I2 = LL, 1, -1
         IF (TEXT(I2:I2) .NE. ' ') THEN
            TE = I2
            RETURN
         ENDIF
      ENDDO
      TE = 1
      TS = 1
      TEXT(1:1) = '~'
      END

C-----------------------------------------------------------------------
C
C SUBROUTINE SEPARATE_PLOTS  -  Create the plots separately
C
C-----------------------------------------------------------------------

      SUBROUTINE SEPARATE_PLOTS(IERR)

      INCLUDE 'sfch_graph.inc'
      INCLUDE 'sfch_html.inc'

      INTEGER IERR
      INTEGER*4 PBOXX1, PBOXX2, PBOXY1, PBOXY2
      INTEGER*4 TS, TE

      IF (.NOT.HTMLF) RETURN

      PBOXX1 = 30
      PBOXX2 = 270
      PBOXY1 = 50
      PBOXY2 = 290
      CALL TRIM (CODE_NDB,TS,TE)

      CALL HTMLOPEN(FILPLHTML,CODE_NDB,IERR)
      IF(IERR.NE.0) GO TO 100

      CALL PSFUNIT (54)

      CALL HTMLCENTER

      CALL HTMLTEXT ('<IMG SRC="'//CODE_NDB(TS:TE)//'_pl1.jpg">')
      CALL PSOPEN (CODE_NDB(TS:TE)//'_pl1.ps',
     +     PBOXX1,PBOXX2,PBOXY1,PBOXY2,MXCOLR,RGB,.FALSE.,1,IERR)
      CALL PSTRANSLATE (80.0, 110.0)
      CALL WILSONPS
      CALL PSCLOS(PBOXX1,PBOXX2,PBOXY1,PBOXY2)

      CALL HTMLTEXT ('<IMG SRC="'//CODE_NDB(TS:TE)//'_pl2.jpg">')
      CALL PSOPEN (CODE_NDB(TS:TE)//'_pl2.ps',
     +     PBOXX1,PBOXX2,PBOXY1,PBOXY2,MXCOLR,RGB,.FALSE.,1,IERR)
      CALL HTMLTEXT('<BR>')
      CALL PSTRANSLATE (80.0, 110.0)
      CALL EFFECTIVPS
      CALL PSCLOS(PBOXX1,PBOXX2,PBOXY1,PBOXY2)

      CALL HTMLTEXT ('<IMG SRC="'//CODE_NDB(TS:TE)//'_pl3.jpg">')
      CALL PSOPEN (CODE_NDB(TS:TE)//'_pl3.ps',
     +     PBOXX1,PBOXX2,PBOXY1,PBOXY2,MXCOLR,RGB,.FALSE.,1,IERR)
      CALL PSTRANSLATE (80.0, 110.0)
      CALL COMPLETEPS
      CALL PSCLOS(PBOXX1,PBOXX2,PBOXY1,PBOXY2)

      CALL HTMLTEXT ('<IMG SRC="'//CODE_NDB(TS:TE)//'_pl4.jpg">')
      CALL PSOPEN (CODE_NDB(TS:TE)//'_pl4.ps',
     +     PBOXX1,PBOXX2,PBOXY1,PBOXY2,MXCOLR,RGB,.FALSE.,1,IERR)
      CALL HTMLTEXT('<BR>')
      CALL PSTRANSLATE (80.0, 110.0)
      CALL ERRORPLOTPS
      CALL PSCLOS(PBOXX1,PBOXX2,PBOXY1,PBOXY2)

      CALL HTMLTEXT ('<IMG SRC="'//CODE_NDB(TS:TE)//'_pl5.jpg">')
      CALL PSOPEN (CODE_NDB(TS:TE)//'_pl5.ps',
     +     PBOXX1,PBOXX2,PBOXY1,PBOXY2,MXCOLR,RGB,.FALSE.,1,IERR)
      CALL PSTRANSLATE (90.0, 110.0)
      CALL STEREOGRAM
      CALL PSCLOS(PBOXX1,PBOXX2,PBOXY1,PBOXY2)

      IF (L_NA) THEN
         CALL HTMLTEXT ('<IMG SRC="'//CODE_NDB(TS:TE)//'_pl6.jpg">')
         CALL PSOPEN (CODE_NDB(TS:TE)//'_pl6.ps',
     +     PBOXX1,PBOXX2,PBOXY1,PBOXY2,MXCOLR,RGB,.FALSE.,1,IERR)
         CALL PSTRANSLATE (80.0, 110.0)
         CALL LUZZATIPS
         CALL PSCLOS(PBOXX1,PBOXX2,PBOXY1,PBOXY2)
      ENDIF

      CALL HTMLECENTER
      CALL HTMLCLOSE

      CALL PSFUNIT (51)

      RETURN

 100  CONTINUE
      CALL MSGERR(0,
     +     ' ERROR (SEPARATE_PLOTS): Can''t create HTML file')

      END
