C-----------------------------------------------------------------------
C
C sfch_graph.inc  -  Common variables for sfplot.f
C
C-----------------------------------------------------------------------

      IMPLICIT NONE
      
      INTEGER IPRROW
      PARAMETER (IPRROW = 21)
      REAL RESULT(IPRROW,45)
      REAL RESULTO(18,73)
      REAL*4 RESVEC(IPRROW), LUZVEC(IPRROW), RFACVC(IPRROW)
      REAL*4 FMEVEC(IPRROW), BOVVEC(IPRROW)
      REAL*4 COMVEC(IPRROW), SIFVEC(IPRROW)
      REAL*4 FREVEC(IPRROW), EFFVEC(IPRROW), EFBVEC(IPRROW)
      REAL*4 ER1VEC(IPRROW), ER2VEC(IPRROW)

      REAL*4 RCODE
      CHARACTER CODE*4
c      EQUIVALENCE (RCODE,CODE)

      REAL*4 RCODE_NDB(2)
      CHARACTER CODE_NDB*8
c      EQUIVALENCE (RCODE_NDB,CODE_NDB)

      REAL*4 CELL(6), RSPGR(3), RMS_L
      CHARACTER SPGR*12
c      EQUIVALENCE (RSPGR,SPGR)

      REAL*4 RNAME(10), RDATE(3)
      CHARACTER SNAME*40, SDATE*12
c      EQUIVALENCE (RDATE,SDATE)
c      EQUIVALENCE (RNAME,SNAME)

      REAL*4 RNDB_TITLE(19), RNDB_DATE(3)
      CHARACTER NDB_TITLE*76, NDB_DATE*12
c      EQUIVALENCE (RNDB_TITLE,NDB_TITLE)
c      EQUIVALENCE (RNDB_DATE,NDB_DATE)

      REAL*4 RCR_PROGRAM(4)
      CHARACTER CR_PROGRAM*16
c      EQUIVALENCE (RCR_PROGRAM,CR_PROGRAM)

      INTEGER NA, NAHOH, NHATOM, NRFLS, N_INPUT, NCS, IGIVEN, NCHAIN
      INTEGER NBAD, NBAD_SD, NBAD_ABS, NOUT, N_GT_SIG, N_GT_3SIG
      INTEGER NMRG, NMRGT, NFREE, NREST, NOMIT, NACT, NMUL, NMULT
      INTEGER NO_USED, NOREST, CR_NREF_REP, NTITLINE
      REAL*4 SOLV, RES_REPORT, RFAC_REPORT, RESEFF
      REAL*4 RSMIN, RSMAX, COMPL, RSTAND, BOVERALL, RES_MIN, RES_MAX
      REAL*4 RFAC, RCORR, RMSL, BOVER, BAVER, RESEFF_COMP
      REAL*4 RFACS, SIGL, RESNL, RESXL, RMRG, RMUL
      REAL*4 CR_RES_MIN, CR_RES_MAX, CR_RES_RMIN, CR_RES_RMAX
      REAL*4 CR_RFAC_CUT, CR_RFAC_ALL, CR_RFAC_OBS
      REAL*4 CR_SIGMAR_I, CR_SIGMAR_F, SIGMAB, SCALE_PATT, BADD_PATT
      REAL*4 CR_RFREE_ALL, CR_RFREE_OBS, CR_RFREE_CUT
      REAL*4 RFAC_FREE_P, RFREE, ERR_MAX, ERR_MIN, DPI_VAL, RF_REST

      LOGICAL L_NCS, L_COMPL, L_NOUT, L_NBAD, L_NBAD_ABS, L_NBA,
     +	L_RMRG, L_SOLV, L_RSTAND, L_RFREE, L_NA, L_NRFLS, L_NFREE,
     +  L_RMUL, L_CODE_NDB, L_NO_USED, L_RES, L_NREF_REP

      INTEGER NANISO,NC_OVER,NC_ANISO
      REAL*4 EVAL1,EVAL2,EVAL3,CKSOL,BSOL,B11,B22,B33,B12,B13,B23,
     +  CMATTHEWS,SOLVENT
      REAL DCORR_TOT
      LOGICAL L_ANISO,L_CMATT,L_NC_ANISO,L_NC_OVER

      INTEGER TOTNBRES, NBOFCHAIN
      REAL*4 DISPSIG, AVERDENS,SIGMADENS
      CHARACTER*256 FILPS
      CHARACTER*80 FILHTML, FILPLHTML, FILREHTML, FILLOHTML
      INTEGER*4 ILEN
      INTEGER*4 IPLOT

      INTEGER*4       BBOXX1, BBOXX2, BBOXY1, BBOXY2
      PARAMETER    (
     -              BBOXX1 =  30,
     -              BBOXX2 = 550,
     -              BBOXY1 =  50,
     -              BBOXY2 = 780
     -             )

      INTEGER*4     NGAPX, NGAPY
      PARAMETER    (NGAPX = 4, NGAPY = 6)

      REAL          RSTART, REND, RGAP, XORIGN, XSEP, XMWID, YORIGN,
     -              YSEP, YMWID, MWIDX, MWIDY, MRAD, YLOWBOX, YSIZREG,
     -              XSIZREG

      PARAMETER    (
     -              REND   = 4.0,
     -              RGAP   = 0.1,
     -              RSTART = 1.0,
     -              XORIGN = 114.0,
     -              XSEP   =  56.0,
     -              XMWID  = 150.0,
     -              YORIGN = 190.0,
     -              YSEP   =  40.0,
     -              YMWID  = 146.0,
     -              MWIDX  =   2.0,
     -              MWIDY  =   2.0,
     -		    MRAD   =   2.0
     -             )

      INTEGER*4 MXCOLR, PLTYPE, COLPLT(3,13)
      PARAMETER    (
     +              MXCOLR = 19
     +             )

      CHARACTER*5 ARING, DEGREE, TWOSUPERIOR, BULLET, ANGLELEFT,
     +		ANGLERIGHT, RADICAL, LEFTPAREN, RIGHTPAREN, LESSEQUAL
      PARAMETER    (
     +              ARING       = 'A    ',
     +              DEGREE      = ' deg ',
     +              TWOSUPERIOR = '^2   ',
     +		    BULLET      = '\\267',
     +		    ANGLELEFT   = '\\341',
     +		    ANGLERIGHT  = '\\361',
     +		    RADICAL     = '\\326',
     +		    LEFTPAREN   = '\\050',
     +		    RIGHTPAREN  = '<    ',
     +              LESSEQUAL   = '>    '
     +             )
c      PARAMETER    (
c     +              ARING = '\\305',
c     +              DEGREE = '\\260',
c     +              TWOSUPERIOR = '\\262',
c     +		    BULLET = '\\267',
c     +		    ANGLELEFT = '\\341',
c     +		    ANGLERIGHT = '\\361',
c     +		    RADICAL = '\\326',
c     +		    LEFTPAREN = '\\050',
c     +		    RIGHTPAREN = '\\051',
c     +              LESSEQUAL = '\\243'
c     +             )

      CHARACTER*(*) HARING, HDEGREE, HTWOSUPERIOR, HBULLET,
     +		HANGLELEFT, HANGLERIGHT
      PARAMETER    (
     +              HARING = '&Aring;',
     +              HDEGREE = '&deg;',
     +              HTWOSUPERIOR = '&sup2;',
     +		    HBULLET     = '&middot;',
     +		    HANGLELEFT  = '&lt;',
     +		    HANGLERIGHT = '&gt;'
     +             )

      REAL RGB(3,MXCOLR)
      CHARACTER*12 COLNAM(MXCOLR)

      COMMON /CHARS/
     +     CODE, CODE_NDB, COLNAM, FILPS, FILHTML, FILPLHTML,
     +     FILREHTML, FILLOHTML
      COMMON /CHARSPGR/
     +     SPGR, SNAME, SDATE, NDB_TITLE, CR_PROGRAM, NDB_DATE

      COMMON /INTS/
     +     ILEN, IPLOT, PLTYPE, COLPLT, NA, NAHOH, NHATOM,
     +     NRFLS, N_INPUT, TOTNBRES, NBOFCHAIN, NCS, IGIVEN, NCHAIN,
     +     NBAD, NBAD_SD, NBAD_ABS, NOUT, N_GT_SIG, N_GT_3SIG,
     +     NMRG, NMRGT, NFREE, NREST, NOMIT, NACT, NMUL, NMULT,
     +     NO_USED, NOREST, CR_NREF_REP, NTITLINE,
     +     NANISO,NC_OVER,NC_ANISO


      COMMON /REALS/
     +     RESULT, RESVEC, LUZVEC, RFACVC, FMEVEC, BOVVEC, COMVEC, 
     +     SIFVEC, FREVEC, EFFVEC, EFBVEC, ER1VEC, ER2VEC,
     +     CELL, RGB, RMS_L, SOLV, RES_REPORT, RFAC_REPORT,
     +     RSMIN, RSMAX,RESEFF, COMPL, RSTAND, BOVERALL, RFAC, RCORR,
     +     RMSL, BOVER, DISPSIG, AVERDENS, SIGMADENS, BAVER,
     +	   RESEFF_COMP, RFACS, SIGL, RESNL, RESXL, YLOWBOX, YSIZREG,
     +     CR_RES_MIN, CR_RES_MAX, CR_RES_RMIN, CR_RES_RMAX,
     +     CR_RFAC_CUT, CR_RFAC_ALL, CR_RFAC_OBS,
     +     CR_SIGMAR_I, CR_SIGMAR_F, RMRG, RMUL,
     +     CR_RFREE_ALL, CR_RFREE_OBS, CR_RFREE_CUT,
     +     RFAC_FREE_P, RFREE, RF_REST, ERR_MAX, ERR_MIN, DPI_VAL,
     +     RESULTO, RES_MIN, RES_MAX, SIGMAB, SCALE_PATT, BADD_PATT,
     +     EVAL1,EVAL2,EVAL3,CKSOL,BSOL,B11,B22,B33,B12,B13,B23,
     +     CMATTHEWS,SOLVENT,XSIZREG

      COMMON /LOGICALS/
     +	   L_NCS, L_COMPL, L_NOUT, L_NBAD, L_NBAD_ABS, L_NBA, L_RMRG,
     +     L_SOLV, L_RSTAND, L_RFREE, L_NA, L_NRFLS, L_NFREE, L_RMUL,
     +     L_CODE_NDB, L_NO_USED, L_RES, L_NREF_REP,
     +     L_ANISO,L_CMATT,L_NC_ANISO,L_NC_OVER

      COMMON /TWINCOM/
     +     IMODE_TWIN,NHTEST,ALPHA_TWIN,TOL_TWIN,FHTEST

      INTEGER IMODE_TWIN,NHTEST
      REAL    ALPHA_TWIN,TOL_TWIN,FHTEST(41)         

      COMMON /TWINCOM_CHAR/ SOP
      CHARACTER SOP*80
      

      COMMON /PSTCOM/
     +     PERSCENT_PST,SPST,IPST

      INTEGER IPST      
      REAL    PERSCENT_PST,SPST(3)  
C --------------------------------------------------------

